<?php
/**
 * Controlador para métodos de un padre de familia aplicante.
 * User: Henry Vivanco <hvvivanco@rutatec.com>
 * Date: 21/1/2019
 * Time: 11:25
 */

namespace App\Http\Controllers;


use App\Repositories\ApplicantGuardianRepository;
use App\Repositories\ApplicantGuardianStudentRepository;
use App\Repositories\ApplicantStudentRepository;
use App\Repositories\MailSuggestoinRepository;
use Illuminate\Http\Request;

class ApplicantGuardianController extends Controller
{
    protected $applicantGuardian;
    protected $applicantStudent;
    protected $mailGuardian;
    protected $applicantGuardianStudent;

    public function __construct(ApplicantGuardianRepository $applicantGuardian, ApplicantStudentRepository $applicantStudent, MailSuggestoinRepository $mailGuardian, ApplicantGuardianStudentRepository $applicantGuardianStudent)
    {
        $this->applicantGuardian = $applicantGuardian;
        $this->applicantStudent = $applicantStudent;
        $this->mailGuardian = $mailGuardian;
        $this->applicantGuardianStudent = $applicantGuardianStudent;
    }

    public function postSaveApplicantGuardian(Request $request){
        try{
            $data = $request->all();
            $father = json_decode($data['father'],true);
            $mother = json_decode($data['mother'],true);
            $father['serial_cou'] = $data['serial_cou'];
            $father['first_name_agd'] = mb_strtoupper($father['first_name_agd'],'utf-8');
            $father['last_name_agd'] = mb_strtoupper($father['last_name_agd'],'utf-8');
            $father['main_street_agd'] = mb_strtoupper($father['main_street_agd'],'utf-8');
            $father['city_residence_agd'] = mb_strtoupper($father['city_residence_agd'],'utf-8');
            $father['sector_agd'] = mb_strtoupper($father['sector_agd'],'utf-8');
            $father['work_company_agd'] = mb_strtoupper($father['work_company_agd'],'utf-8');
            $father['number_applicants_agd'] = $data['number_applicants_agd'];
            $applicantFather = $this->applicantGuardian->saveApplicantGuardian($father);
            if($data['father_repre'] == 'YES'){
                $applicantGuardian = $applicantFather;
            }
            $mother['serial_cou'] = $data['serial_cou'];
            $mother['first_name_agd'] = mb_strtoupper($mother['first_name_agd'],'utf-8');
            $mother['last_name_agd'] = mb_strtoupper($mother['last_name_agd'],'utf-8');
            $mother['main_street_agd'] = mb_strtoupper($mother['main_street_agd'],'utf-8');
            $mother['city_residence_agd'] = mb_strtoupper($mother['city_residence_agd'],'utf-8');
            $mother['sector_agd'] = mb_strtoupper($mother['sector_agd'],'utf-8');
            $mother['work_company_agd'] = mb_strtoupper($mother['work_company_agd'],'utf-8');
            $mother['number_applicants_agd'] = $data['number_applicants_agd'];
            $applicantMother = $this->applicantGuardian->saveApplicantGuardian($mother);
            if($data['mother_repre'] == 'YES'){
                $applicantGuardian = $applicantMother;
            }
            $students = json_decode($data['students'],true);
            foreach ($students as $key => $student) {
                $student['first_name_ast'] = mb_strtoupper($student['first_name_ast'],'utf-8');
                $student['last_name_ast'] = mb_strtoupper($student['last_name_ast'],'utf-8');
                $student['school_city_last_school_ast'] = mb_strtoupper($student['school_city_last_school_ast'],'utf-8');
                $student['last_school_ast'] = mb_strtoupper($student['last_school_ast'],'utf-8');
                $student['serial_agd'] = $applicantGuardian->serial_agd;
                $student['serial_scy'] = $data['serial_scy'];
                $student['ip_address_ast'] = $data['ip_address_ast'];
                $applicant = $this->applicantStudent->saveApplicantStudent($student);
                $applicantFatherStudent['serial_agd'] = $applicantFather->serial_agd;
                $applicantFatherStudent['serial_ast'] = $applicant->serial_ast;
                $applicantFatherStudent['relationship_ast'] = 'FATHER';
                $this->applicantGuardianStudent->saveApplicantGuardianStudent($applicantFatherStudent);
                $applicantMotherStudent['serial_agd'] = $applicantMother->serial_agd;
                $applicantMotherStudent['serial_ast'] = $applicant->serial_ast;
                $applicantMotherStudent['relationship_ast'] = 'MOTHER';
                $this->applicantGuardianStudent->saveApplicantGuardianStudent($applicantMotherStudent);
            }

            $this->mailGuardian->mailApplicantGuardian($applicantGuardian);
            $this->mailGuardian->mailApplicantApprover($applicantGuardian);
            return response()->json(['success' => 'true',
                'message' => 'Se ha registrado la solicitud'], 200);

        }catch (Exception $ex){
            return response()->json($ex);
        }
    }

}