<?php
/**
 * Controlador para métodos sobre pais.
 * User: Henry Vivanco <hvvivanco@rutatec.com>
 * Date: 21/1/2019
 * Time: 15:26
 */

namespace App\Http\Controllers;


use App\Repositories\CountryRepository;

class CountryController extends Controller
{
    protected $country;

    public function __construct(CountryRepository $country)
    {
        $this->country = $country;
    }

    /**
     * Método para obtener lista de países
     * @author Henry Vivanco <hvvivanco@rutatec.com>
     * @since  2019-01-21
     * @return array $countries
     */
    public function getCountries(){
        $countries = $this->country->getCountries();
        return response()->json($countries);
    }

}