<?php
/**
 * Controlador para métodos sobre cantones.
 * User: Henry Vivanco <hvvivanco@rutatec.com>
 * Date: 21/1/2019
 * Time: 15:35
 */

namespace App\Http\Controllers;


use App\Repositories\CountiesRepository;
use Illuminate\Http\Request;

class CountyController extends Controller
{
    protected $counties;

    public function __construct(CountiesRepository $counties)
    {
        $this->counties = $counties;
    }

    /**
     * Método para obtener cantones(condados) según el estado
     * @author Henry Vivanco <hvvivanco@rutatec.com>
     * @since  2019-01-21
     * @return array $counties
     */
    public function getCounties(Request $request){
        $this->validate($request, [
            'serial_ste' => 'required',
        ]);
        $serialState = $request->get('serial_ste');
        $counties = $this->counties->getCounties($serialState);
        return response()->json($counties);
    }

}