<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Repositories\EnumRepository;
use Laravel\Lumen\Routing\Controller as BaseController;

/**
 * Controlador para manejar enumeradores
 * @since   2017-07-09
 * @author  Erick Vaca <epvaca@rutatec.com>
 *
 * @edit    2017-07-09<br />
 *          Erick Vaca <epvaca@rutatec.com><br /><br/>
 *          Creación del controlador<br/>
 *          #edit1
 */
class EnumController extends BaseController {

    protected $enum;

    /**
     * Constructor
     * @since   2016-07-09
     * @param   EnumRepository  $enum repositorio
     * @author   Erick Vaca <epvaca@rutatec.com><br /><br/>
     *
     */
    public function __construct(EnumRepository $enum){
        $this->enum = $enum;
    }

    /**
     * Método para obtener tipos de materias
     * @since   2016-07-09
     * @author   Erick Vaca <epvaca@rutatec.com><br /><br/>
     * @return  json resultado
     *
     */
    public function getSubjectTypes(){

        $subjectTypes = $this->enum->getSubjectTypes();

        return response()->json($subjectTypes);        
    }


}