<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Repositories\LevelSectionYearRepository;
use Laravel\Lumen\Routing\Controller as BaseController;

class LevelSectionYearController extends BaseController {

    protected $levelSectionYear;

    public function __construct(LevelSectionYearRepository $levelSectionYear) {
        $this->levelSectionYear = $levelSectionYear;      
    }

    /**
     * Método que devuelve los datos de LevelSectionYear por anio, section, nivel
     * @since   2018-04-01
     * @author  Erick Vaca <epvaca@rutatec.com>
     *
     * @param   array $request 
     * @return  ListObject $subperiod
     * 
     * @edit    2018-04-01<br />
     *          Erick Vaca <epvaca@rutatec.com><br />
     *          Creación del método<br/>
     *          #edit1
     */
    public function postLevelSectionYearBySchoolYearSectionLevel(Request $request) {
        $this->validate($request, [            
            'serial_scy' => 'required',
            'serial_lvl' => 'required',
            'serial_set' => 'required'
        ]);
        $lsy = $this->levelSectionYear->getLevelSectionYearBySchoolYearSectionLevel($request->input('serial_scy'),$request->input('serial_set'),$request->input('serial_lvl'));

        return response()->json($lsy);
    }

    /**
     * Método para obtener nivel por sección y año
     * @author Henry Vivanco <hvvivanco@rutatec.com>
     * @since  2019-01-21
     * @return array $countries
     */
    public function getLevelByYearAndSection(Request $request){
        $this->validate($request, [
            'serial_scy' => 'required',
            'serial_set' => 'required'
        ]);
        $serialSchoolYear = $request->get('serial_scy');
        $serialSection = $request->get('serial_set');
        $levels = $this->levelSectionYear->getLevelByYearAndSection($serialSchoolYear,$serialSection);
        return response()->json($levels);
    }

}
