<?php
/**
 * Controlador para métodos sobre parroquia.
 * User: Henry Vivanco <hvvivanco@rutatec.com>
 * Date: 21/1/2019
 * Time: 15:39
 */

namespace App\Http\Controllers;


use App\Repositories\ParishRepository;
use Illuminate\Http\Request;

class ParishController extends Controller
{
    protected $parish;

    public function __construct(ParishRepository $parish)
    {
        $this->parish = $parish;
    }
    /**
     * Método para obtener cantones(condados) según el estado
     * @author Henry Vivanco <hvvivanco@rutatec.com>
     * @since  2019-01-21
     * @return array $countries
     */
    public function getParish(Request $request){
        $this->validate($request, [
            'serial_cnt' => 'required',
        ]);
        $serialCounties = $request->get('serial_cnt');
        $parish = $this->parish->getParish($serialCounties);
        return response()->json($parish);
    }

}