<?php

namespace App\Http\Controllers;

use App\Repositories\SessionPlanningWeekRepository;
use App\Repositories\UnitPlanningWeekRepository;
use Illuminate\Http\Request;
use Laravel\Lumen\Routing\Controller as BaseController;

use App\Repositories\SubjectGroupPlanningRepository;
use App\Repositories\SubjectYearPlanningRepository;
use App\Repositories\DateDayConfigurationRepository;
use App\Repositories\OptionalSubjectRepository;
use App\Repositories\SubjectCourseRepository;
use App\Repositories\ScheduleRepository;
use App\Repositories\UnitPlanningFormRepository;

//levels
use App\Repositories\LevelGeneralObjectivesRepository;
use App\Repositories\LevelSpecificObjectivesRepository;
use App\Repositories\LevelTransverseAxisRepository;
use App\Repositories\LevelPlanningUnitRepository;
use App\Repositories\LevelObjectiveUnitRepository;
use App\Repositories\LevelUnitSkillRepository;
use App\Repositories\LevelMethodologicalOrientationUnitRepository;
use App\Repositories\LevelEvaluationIndicatorsRepository;
use App\Repositories\LevelTransverseUnitRepository;
use App\Repositories\LevelStrategiesUnitRepository;
use App\Repositories\LevelResourcesUnitRepository;
use App\Repositories\LevelIndicatorsUnitRepository;


//catalogs
use App\Repositories\PlanningTransverseAxisRepository;
use App\Repositories\PlanningSpecificObjectiveRepository;
use App\Repositories\GeneralAreaObjectiveRepository;
use App\Repositories\PlanningUnitRepository;
use App\Repositories\SpecificObjectiveUnitRepository;
use App\Repositories\PlanningUnitSkillsRepository;
use App\Repositories\MethodologicalOrientationUnitRepository;
use App\Repositories\EvaluationIndicatorsUnitRepository;
use App\Repositories\TransverseAxisUnitRepository;
use App\Repositories\MethodologicalStrategiesUnitRepository;
use App\Repositories\ResourcesPlanningUnitRepository;
use App\Repositories\AchievementIndicatorsUnitRepository;

//subjects
use App\Repositories\SubjectGeneralObjectivesRepository;
use App\Repositories\SubjectTransverseAxisRepository;
use App\Repositories\SubjectSpecificObjectivesRepository;
use App\Repositories\SubjectPlanningUnitRepository;
use App\Repositories\SubjectObjectiveUnitRepository;
use App\Repositories\SubjectUnitSkillRepository;
use App\Repositories\SubjectMethodologicalOrientationRepository;
use App\Repositories\SubjectEvaluationIndicatorsRepository;
use App\Repositories\SubjectTransverseUnitRepository;
use App\Repositories\SubjectStrategiesUnitRepository;
use App\Repositories\SubjectResourcesUnitRepository;
use App\Repositories\SubjectIndicatorsUnitRepository;


class PlanningController extends BaseController {

    protected $subject_group_planning;
    protected $subject_year_planning;
    protected $subject_general_objectives;
    protected $schedule;
    protected $date_day_configuration;
    protected $level_general_objectives;
    protected $general_area_objectives;
    protected $subject_course;
    protected $optional_subject;
    protected $level_specific_objectives;
    protected $planning_specific_objectives;
    protected $subject_specific_objectives;
    protected $level_transverse_axis;
    protected $planning_transverse_axis;
    protected $subject_transverse_axis;
    protected $level_planning_unit;
    protected $planning_unit;
    protected $subject_planning_unit;
    protected $level_objective_unit;
    protected $specific_objective_unit;
    protected $subject_objective_unit;
    protected $level_unit_skills;
    protected $planning_unit_skills;
    protected $subject_unit_skills;
    protected $level_methodological_orientation;
    protected $methodological_orientation_unit;
    protected $subject_methodological_orientation;
    protected $level_evaluation_indicators;
    protected $evaluation_indicators_unit;
    protected $subject_evaluation_indicators;
    protected $level_transverse_unit;
    protected $transverse_axis_unit;
    protected $subject_transverse_unit;
    protected $level_strategies_unit;
    protected $methodological_strategies_unit;
    protected $subject_strategies_unit;
    protected $level_resources_unit;
    protected $resources_planning_unit;
    protected $subject_resources_unit;
    protected $level_indicators_unit;
    protected $subject_indicators_unit;
    protected $achievement_indicators_unit;
    protected $unit_planning_form;
    protected $unit_planning_week;
    protected $session_planning_week;

    public function __construct(SubjectGroupPlanningRepository $subject_group_planning,
                                SubjectYearPlanningRepository $subject_year_planning,
                                ScheduleRepository $schedule,
                                SubjectCourseRepository $subject_course,
                                OptionalSubjectRepository $optional_subject,
                                DateDayConfigurationRepository $date_day_configurationRepository,
                                LevelGeneralObjectivesRepository $levelGeneralObjectivesRepository,
                                SubjectGeneralObjectivesRepository $subjectGeneralObjectivesRepository,
                                GeneralAreaObjectiveRepository $generalAreaObjectiveRepository,
                                LevelSpecificObjectivesRepository $levelSpecificObjectivesRepository,
                                SubjectSpecificObjectivesRepository $subjectSpecificObjectivesRepository,
                                PlanningSpecificObjectiveRepository $planningSpecificObjectiveRepository,
                                LevelTransverseAxisRepository $levelTransverseAxisRepository,
                                SubjectTransverseAxisRepository $subjectTransverseAxisRepository,
                                PlanningTransverseAxisRepository $planningTransverseAxisRepository,
                                LevelPlanningUnitRepository $levelPlanningUnitRepository,
                                SubjectPlanningUnitRepository $subjectPlanningUnitRepository,
                                PlanningUnitRepository $planningUnitRepository,
                                LevelObjectiveUnitRepository $levelObjectiveUnitRepository,
                                SubjectObjectiveUnitRepository $subjectObjectiveUnitRepository,
                                SpecificObjectiveUnitRepository $specificObjectiveUnitRepository,
                                //
                                LevelUnitSkillRepository $levelUnitSkillRepository,
                                SubjectUnitSkillRepository $subjectUnitSkillRepository,
                                PlanningUnitSkillsRepository $planningUnitSkillsRepository,
                                //
                                LevelMethodologicalOrientationUnitRepository $levelMethodologicalOrientationRepository,
                                SubjectMethodologicalOrientationRepository $subjectMethodologicalOrientationRepository,
                                MethodologicalOrientationUnitRepository $methodologicalOrientationUnitRepository,
                                //
                                LevelEvaluationIndicatorsRepository $levelEvaluationIndicatorsRepository,
                                SubjectEvaluationIndicatorsRepository $subjectEvaluationIndicatorsRepository,
                                EvaluationIndicatorsUnitRepository $evaluationIndicatorsUnitRepository,
                                //
                                TransverseAxisUnitRepository $transverseAxisUnitRepository,
                                LevelTransverseUnitRepository $levelTransverseUnitRepository,
                                SubjectTransverseUnitRepository $subjectTransverseUnitRepository,
                                //
                                MethodologicalStrategiesUnitRepository $methodologicalStrategiesUnitRepository,
                                LevelStrategiesUnitRepository $levelStrategiesUnitRepository,
                                SubjectStrategiesUnitRepository $subjectStrategiesUnitRepository,
                                //
                                ResourcesPlanningUnitRepository $resourcesPlanningUnitRepository,
                                LevelResourcesUnitRepository $levelResourcesUnitRepository,
                                SubjectResourcesUnitRepository $subjectResourcesUnitRepository,
                                //
                                AchievementIndicatorsUnitRepository $achievementIndicatorsUnitRepository,
                                LevelIndicatorsUnitRepository $levelIndicatorsUnitRepository,
                                SubjectIndicatorsUnitRepository $subjectIndicatorsUnitRepository,
                                //
                                UnitPlanningFormRepository $unitPlanningFormRepository,
                                UnitPlanningWeekRepository $unitPlanningWeekRepository,
                                SessionPlanningWeekRepository $sessionPlanningWeekRepository

    ) {
        $this->subject_group_planning = $subject_group_planning;
        $this->subject_year_planning = $subject_year_planning;
        $this->level_general_objectives = $levelGeneralObjectivesRepository;
        $this->subject_general_objectives = $subjectGeneralObjectivesRepository;
        $this->general_area_objectives = $generalAreaObjectiveRepository;
        $this->schedule = $schedule;
        $this->subject_course = $subject_course;
        $this->optional_subject = $optional_subject;
        $this->level_specific_objectives = $levelSpecificObjectivesRepository;
        $this->subject_specific_objectives = $subjectSpecificObjectivesRepository;
        $this->planning_specific_objectives = $planningSpecificObjectiveRepository;
        $this->date_day_configuration= $date_day_configurationRepository;
        $this->level_transverse_axis = $levelTransverseAxisRepository;
        $this->subject_transverse_axis = $subjectTransverseAxisRepository;
        $this->planning_transverse_axis = $planningTransverseAxisRepository;
        $this->level_planning_unit = $levelPlanningUnitRepository;
        $this->subject_planning_unit = $subjectPlanningUnitRepository;
        $this->planning_unit = $planningUnitRepository;
        $this->level_objective_unit = $levelObjectiveUnitRepository;
        $this->subject_objective_unit = $subjectObjectiveUnitRepository;
        $this->specific_objective_unit = $specificObjectiveUnitRepository;
        $this->level_unit_skills = $levelUnitSkillRepository;
        $this->subject_unit_skills = $subjectUnitSkillRepository;
        $this->planning_unit_skills = $planningUnitSkillsRepository;
        $this->level_methodological_orientation = $levelMethodologicalOrientationRepository;
        $this->subject_methodological_orientation = $subjectMethodologicalOrientationRepository;
        $this->methodological_orientation_unit = $methodologicalOrientationUnitRepository;
        $this->level_evaluation_indicators = $levelEvaluationIndicatorsRepository;
        $this->subject_evaluation_indicators = $subjectEvaluationIndicatorsRepository;
        $this->evaluation_indicators_unit = $evaluationIndicatorsUnitRepository;
        $this->level_transverse_unit = $levelTransverseUnitRepository;
        $this->subject_transverse_unit = $subjectTransverseUnitRepository;
        $this->transverse_axis_unit = $transverseAxisUnitRepository;
        $this->level_strategies_unit = $levelStrategiesUnitRepository;
        $this->subject_strategies_unit = $subjectStrategiesUnitRepository;
        $this->methodological_strategies_unit= $methodologicalStrategiesUnitRepository;
        $this->level_resources_unit = $levelResourcesUnitRepository;
        $this->subject_resources_unit = $subjectResourcesUnitRepository;
        $this->resources_planning_unit = $resourcesPlanningUnitRepository;
        $this->level_indicators_unit = $levelIndicatorsUnitRepository;
        $this->subject_indicators_unit = $subjectIndicatorsUnitRepository;
        $this->achievement_indicators_unit = $achievementIndicatorsUnitRepository;
        $this->unit_planning_form = $unitPlanningFormRepository;
        $this->unit_planning_week = $unitPlanningWeekRepository;
        $this->session_planning_week = $sessionPlanningWeekRepository;
    }


    /**
     * Cargar planificacion anual por materia
     * @since   2019-01-15
     * @param   integer serial_sbc
     * @param   integer serial_osb
     * @param   integer serial_lvl
     * @param   integer serial_set
     * @param   integer serial_scy
     * @author   Jairo Serrano <jaserrano@rutatec.com><br /><br/>
     * @return  json resultado
     *
     */
    public function postSubjectYearPlanning(Request $request) {

        $this->validate($request, [
            'serial_lvl' => 'required',
            'serial_set' => 'required',
            'serial_scy' => 'required',
        ]);

        $subjectYearInfo = $this->subject_group_planning->getSubjectGroupPlanning($request->input('serial_sbc'), $request->input('serial_osb'), $request->input('serial_lvl'), $request->input('serial_set'), $request->input('serial_scy'));
        if ($subjectYearInfo) {
            if ($subjectYearInfo->subjectYearPlanning == null) {
                //calcular los campos de planificacion anual en base a la materia
                if (strtoupper($request->input('serial_sbc')) != 'NULL') {
                    $scheduleSubject = $this->schedule->getScheduleBySerialSubject($request->input('serial_sbc'));
                }elseif (strtoupper($request->input('serial_osb')) != 'NULL') {
                    $scheduleSubject = $this->schedule->getScheduleBySerialSubject(null, $request->input('serial_osb'));
                }
                $subjectYearPlanning = array('name_syp' => null, 'description_syp' => null, 'workload_syp' => sizeof($scheduleSubject), 'unforeseen_syp' => 0);
                //obtener numero de semanas en base a fecha inicio y fin del año configurado
                $startAndEndDate = $this->date_day_configuration->getStartAndEndDatesByYear($request->input('serial_scy'));
                $startTime = strtotime($startAndEndDate['startDate']);
                $endTime = strtotime($startAndEndDate['endDate']);
                $weeks = array();
                while ($startTime < $endTime) {
                    $weeks[] = date('W', $startTime);
                    $startTime += strtotime('+1 week', 0);
                }
                $subjectYearPlanning['weeks_number_syp'] = sizeof($weeks);
                $subjectYearPlanning['total_weekly_classes_syp'] = sizeof($weeks);
                $subjectYearPlanning['total_periods_syp'] = sizeof($weeks) * sizeof($scheduleSubject);
                return response()->json($subjectYearPlanning);
            } else {
                //obtener planificacion anual previamente configurada
                return response()->json($subjectYearInfo->subjectYearPlanning);
            }
        } else {
            return response()->json('La materia no registra planificaci&oacute;n', 404);
        }

    }

    //guardar planificación anual por materia
    public function postSaveSubjectYearPlanning(Request $request) {
        $this->validate($request, [
            'name_syp' => 'required',
            'description_syp' => 'required',
            'workload_syp' => 'required',
            'weeks_number_syp' => 'required',
            'unforeseen_syp' => 'required',
            'total_weekly_classes_syp' => 'required',
            'total_periods_syp' => 'required',
            'serial_sgp' => 'required'
        ]);

        try {
            $result = $this->subject_year_planning->saveSubjectYearPlanning($request);
            return response()->json($result);
        } catch (Exception $ex) {
            return response()->json('Existieron errores al guardar la planificación anual',500);
        }
    }

    public function postSubjectGroupConfiguration(Request $request) {
        $this->validate($request, [
            'serial_lvl' => 'required',
            'serial_set' => 'required',
            'serial_scy' => 'required',
        ]);
        $subjectYearInfo = $this->subject_group_planning->getSubjectGroupPlanning($request->input('serial_sbc'), $request->input('serial_osb'), $request->input('serial_lvl'), $request->input('serial_set'), $request->input('serial_scy'));
        if ($subjectYearInfo) {
            return response()->json($subjectYearInfo, 200);
        } else {
            return response()->json('La materia no registra planificaci&oacute;n', 404);
        }
    }

    public function getSelectableGeneralObjectivesBySubject($serial_sbc, $serial_osb, $serial_lvl, $serial_set) {
        $listObjectives = $this->level_general_objectives->getLevelGeneralObjectivesSelectable($serial_sbc, $serial_osb, $serial_lvl, $serial_set);
        if ($listObjectives) {
            return response()->json($listObjectives, 200);
        } else {
            return response()->json('No existen objectivos configurados para el nivel', 404);
        }
    }

    public function getGeneralObjectivesBySubject($serial_syp) {
        $listObjectives = $this->subject_year_planning->getLevelGeneralObjectives($serial_syp);
        if ($listObjectives) {
            return response()->json($listObjectives, 200);
        } else {
            return response()->json('No existen objectivos configurados para el nivel', 404);
        }
    }

    //función para asignar o desasignar objetivo de area
    public function postSetGeneralObjectiveToSubject(Request $request) {
        $this->validate($request, [
            'serial_syp' => 'required',
            'serial_lgo' => 'required'
        ]);

        try {
            $result =$this->subject_general_objectives->setGeneralObjectiveToSubjectYearPlanning($request);
            if($result){
                return response()->json($result,200);
            }else{
                return response()->json('No se pudo asignar objetivo',200);
            }
        } catch (Exception $ex) {
            return response()->json('Existieron errores al asignar objetivo',500);
        }
    }

    public function postCreateGeneralObjective(Request $request) {
        $this->validate($request, [
            'description_gao' => 'required',
            'is_ministry_objective' => 'required',
            'serial_syp'=> 'required'
        ]);

        try {
            $generalAreaObjective =$this->general_area_objectives->saveGeneralAreaObjectives($request);
            if($generalAreaObjective){
                $subjectYearPlanning=$this->subject_year_planning->getSubjectYearPlanning($request->get('serial_syp'));
                $subjectsGroupPlanning=$subjectYearPlanning->subjectGroupPlanning()->first();
                   if($subjectsGroupPlanning){
                       if($subjectsGroupPlanning->serial_sbc){
                           $subject = $this->subject_course->getSubjectCourseInformation($subjectsGroupPlanning->serial_sbc);
                       }else if($subjectsGroupPlanning->serial_osb){
                           $subject = $this->optional_subject->getOptionalSubjectInformationBySerialOsb($subjectsGroupPlanning->serial_osb);
                       }
                       $levelGeneralObjective= $this->level_general_objectives->saveLevelGeneralObjective($subjectsGroupPlanning->serial_lvl,
                           $subjectsGroupPlanning->serial_set,$generalAreaObjective->serial_gao,$subject[0]['serial_aca']);

                       if($levelGeneralObjective && $generalAreaObjective){

                           $data['serial_syp']=$request->get('serial_syp');
                           $data['serial_lgo']=$levelGeneralObjective->serial_lgo;
                           try {
                               $result =$this->subject_general_objectives->setGeneralObjectiveToSubjectYearPlanning($data);
                               if($result){
                                   return response()->json($result,200);
                               }else{
                                   return response()->json('No se pudo asignar objetivo',200);
                               }
                           } catch (Exception $ex) {
                               return response()->json('Existieron errores al asignar objetivo',500);
                           }
                       }else{
                           return response()->json('Existieron errores en la creacion del objetivo general');
                       }
                   }else{
                       return response()->json('La planificaci&oacute;n anual no se ha creado correctamente',500);
                   }

            }else{
                return response()->json('No se pudo crear objetivo',500);
            }
        } catch (Exception $ex) {
            return response()->json('Existieron errores al crear objetivo',500);
        }
    }

    //objetivos especificos

    public function getSelectableSpecificObjectivesBySubject($serial_sbc, $serial_osb, $serial_lvl, $serial_set) {
        $listObjectives = $this->level_specific_objectives->getLevelSpecificObjectivesSelectable($serial_sbc, $serial_osb, $serial_lvl, $serial_set);
        if ($listObjectives) {
            return response()->json($listObjectives, 200);
        } else {
            return response()->json('No existen objectivos especificos configurados para el nivel', 404);
        }
    }

    public function getSpecificObjectivesBySubject($serial_syp) {
        $listObjectives = $this->subject_year_planning->getLevelSpecificObjectives($serial_syp);
        if ($listObjectives) {
            return response()->json($listObjectives, 200);
        } else {
            return response()->json('No existen objectivos especificos configurados para el nivel', 404);
        }
    }

    //función para asignar o desasignar objetivo de area
    public function postSetSpecificObjectiveToSubject(Request $request) {
        $this->validate($request, [
            'serial_syp' => 'required',
            'serial_lso' => 'required'
        ]);

        try {
            $result =$this->subject_specific_objectives->setSpecificObjectivesToSubjectYearPlanning($request);
            if($result){
                return response()->json($result,200);
            }else{
                return response()->json('No se pudo asignar objetivo especifico',200);
            }
        } catch (Exception $ex) {
            return response()->json('Existieron errores al asignar objetivo especifico',500);
        }
    }

    public function postCreateSpecificObjective(Request $request) {
        $this->validate($request, [
            'description_pso' => 'required',
            'is_ministry_objective' => 'required',
            'serial_syp'=> 'required'
        ]);

        try {
            $planningSpecificObjective =$this->planning_specific_objectives->savePlanningSpecificObjectives($request);
            if($planningSpecificObjective){
                $subjectYearPlanning=$this->subject_year_planning->getSubjectYearPlanning($request->get('serial_syp'));
                $subjectsGroupPlanning=$subjectYearPlanning->subjectGroupPlanning()->first();
                if($subjectsGroupPlanning){
                    if($subjectsGroupPlanning->serial_sbc){
                        $subject = $this->subject_course->getSubjectCourseInformation($subjectsGroupPlanning->serial_sbc);
                    }else if($subjectsGroupPlanning->serial_osb){
                        $subject = $this->optional_subject->getOptionalSubjectInformationBySerialOsb($subjectsGroupPlanning->serial_osb);
                    }
                    $levelSpecificObjective= $this->level_specific_objectives->saveLevelSpecificObjective($subjectsGroupPlanning->serial_lvl,
                        $subjectsGroupPlanning->serial_set,$planningSpecificObjective->serial_pso,$subject[0]['serial_aca']);

                    if($levelSpecificObjective && $planningSpecificObjective){

                        $data['serial_syp']=$request->get('serial_syp');
                        $data['serial_lso']=$levelSpecificObjective->serial_lso;
                        try {
                            $result =$this->subject_specific_objectives->setSpecificObjectivesToSubjectYearPlanning($data);
                            if($result){
                                return response()->json($result,200);
                            }else{
                                return response()->json('No se pudo asignar objetivo especifico',200);
                            }
                        } catch (Exception $ex) {
                            return response()->json('Existieron errores al asignar objetivo especifico',500);
                        }
                    }else{
                        return response()->json('Existieron errores en la creacion del objetivo especifico');
                    }
                }else{
                    return response()->json('La planificaci&oacute;n anual no se ha creado correctamente',500);
                }

            }else{
                return response()->json('No se pudo crear objetivo especifico',500);
            }
        } catch (Exception $ex) {
            return response()->json('Existieron errores al crear objetivo especifico',500);
        }
    }

    //ejes transversales

    public function getSelectableTransverseAxesBySubject($serial_sbc, $serial_osb, $serial_lvl, $serial_set) {
        $listTransverseAxes = $this->level_transverse_axis->getLevelTransverseAxisSelectable($serial_sbc, $serial_osb, $serial_lvl, $serial_set);
        if ($listTransverseAxes) {
            return response()->json($listTransverseAxes, 200);
        } else {
            return response()->json('No existen ejes transversales configurados para el nivel', 404);
        }
    }

    public function getTransverseAxesBySubject($serial_syp) {
        $listTransverseAxes = $this->subject_year_planning->getLevelTransverseAxis($serial_syp);
        if ($listTransverseAxes) {
            return response()->json($listTransverseAxes, 200);
        } else {
            return response()->json('No existen ejes transversales configurados para el nivel', 404);
        }
    }

    //función para asignar o desasignar eje transversal
    public function postSetTransverseAxesToSubject(Request $request) {
        $this->validate($request, [
            'serial_syp' => 'required',
            'serial_ltx' => 'required'
        ]);

        try {
            $result =$this->subject_transverse_axis->setTransverseAxisToSubjectYearPlanning($request);
            if($result){
                return response()->json($result,200);
            }else{
                return response()->json('No se pudo asignar eje transversal',200);
            }
        } catch (Exception $ex) {
            return response()->json('Existieron errores al asignar eje transversal',500);
        }
    }

    public function postCreateTransverseAxis(Request $request) {
        $this->validate($request, [
            'description_ptx' => 'required',
            'is_ministry_ptx' => 'required',
            'serial_syp'=> 'required'
        ]);

        try {
            $planningTransverseAxis =$this->planning_transverse_axis->savePlanningTransverseAxis($request);
            if($planningTransverseAxis){
                $subjectYearPlanning=$this->subject_year_planning->getSubjectYearPlanning($request->get('serial_syp'));
                $subjectsGroupPlanning=$subjectYearPlanning->subjectGroupPlanning()->first();
                if($subjectsGroupPlanning){
                    if($subjectsGroupPlanning->serial_sbc){
                        $subject = $this->subject_course->getSubjectCourseInformation($subjectsGroupPlanning->serial_sbc);
                    }else if($subjectsGroupPlanning->serial_osb){
                        $subject = $this->optional_subject->getOptionalSubjectInformationBySerialOsb($subjectsGroupPlanning->serial_osb);
                    }
                    $levelTransverseAxis= $this->level_transverse_axis->saveLevelTransverseAxis($subjectsGroupPlanning->serial_lvl,
                        $subjectsGroupPlanning->serial_set,$planningTransverseAxis->serial_ptx,$subject[0]['serial_aca']);

                    if($levelTransverseAxis && $planningTransverseAxis){

                        $data['serial_syp']=$request->get('serial_syp');
                        $data['serial_ltx']=$levelTransverseAxis->serial_ltx;
                        try {
                            $result =$this->subject_transverse_axis->setTransverseAxisToSubjectYearPlanning($data);
                            if($result){
                                return response()->json($result,200);
                            }else{
                                return response()->json('No se pudo asignar eje transversal',200);
                            }
                        } catch (Exception $ex) {
                            return response()->json('Existieron errores al asignar eje transversal',500);
                        }
                    }else{
                        return response()->json('Existieron errores en la creacion del eje transversal');
                    }
                }else{
                    return response()->json('La planificaci&oacute;n anual no se ha creado correctamente',500);
                }
            }else{
                return response()->json('No se pudo crear eje transversal',500);
            }
        } catch (Exception $ex) {
            return response()->json('Existieron errores al crear eje transversal',500);
        }
    }

    //Unidades de planificacion

    public function getSelectablePlanningUnitsBySubject($serial_sbc, $serial_osb, $serial_lvl, $serial_set) {
        $listPlanningUnits = $this->level_planning_unit->getLevelPlanningUnitSelectable($serial_sbc, $serial_osb, $serial_lvl, $serial_set);
        if ($listPlanningUnits) {
            return response()->json($listPlanningUnits, 200);
        } else {
            return response()->json('No existen unidades de planificacion configuradas para el nivel', 404);
        }
    }

    public function getPlanningUnitsBySubject($serial_syp) {
        $listPlanningUnits = $this->subject_year_planning->getLevelPlanningUnits($serial_syp);
        if ($listPlanningUnits) {
            foreach ($listPlanningUnits as $key => $item){
                $count = 0;
                $specificObjectivesUnit = $this->subject_planning_unit->getLevelObjectivesUnit($item['serial_spu']);
                $skillsUnit = $this->subject_planning_unit->getLevelUnitSkill($item['serial_spu']);
                $orientationUnit = $this->subject_planning_unit->getLevelMethodologicalOrientation($item['serial_spu']);
                $evaluationUnit = $this->subject_planning_unit->getLevelEvaluationIndicators($item['serial_spu']);
                $axisUnit = $this->subject_planning_unit->getLevelTransverseUnit($item['serial_spu']);
                $strategiesUnit = $this->subject_planning_unit->getLevelStrategiesUnit($item['serial_spu']);
                $resourceUnit = $this->subject_planning_unit->getLevelResourcesUnit($item['serial_spu']);
                $achievementUnit = $this->subject_planning_unit->getLevelIndicatorsUnit($item['serial_spu']);
                $listPlanningUnits[$key]['specific_objectives'] = count($specificObjectivesUnit);
                $count = count($specificObjectivesUnit) > 0 ? $count+1 : $count;
                $listPlanningUnits[$key]['skill_unit'] = count($skillsUnit);
                $count = count($skillsUnit) > 0 ? $count+1 : $count;
                $listPlanningUnits[$key]['orientation_unit'] = count($orientationUnit);
                $count = count($orientationUnit) > 0 ? $count+1 : $count;
                $listPlanningUnits[$key]['evaluation_unit'] = count($evaluationUnit);
                $count = count($evaluationUnit) > 0 ? $count+1 : $count;
                $listPlanningUnits[$key]['axis_unit'] = count($axisUnit);
                $count = count($axisUnit) > 0 ? $count+1 : $count;
                $listPlanningUnits[$key]['strategies_unit'] = count($strategiesUnit);
                $count = count($strategiesUnit) > 0 ? $count+1 : $count;
                $listPlanningUnits[$key]['resource_unit'] = count($resourceUnit);
                $count = count($resourceUnit) > 0 ? $count+1 : $count;
                $listPlanningUnits[$key]['achievement_unit'] = count($achievementUnit);
                $count = count($achievementUnit) > 0 ? $count+1 : $count;
                $total = ($count * 100)/8;
                $listPlanningUnits[$key]['total'] = $total;
            }
            return response()->json($listPlanningUnits, 200);
        } else {
            return response()->json('No existen unidades de planificacion configuradas para el nivel', 404);
        }
    }
    public function getLevelForm($serial_syp) {
        //check if has form configured
        $levelForm=$this->subject_year_planning->getLevelPlanningForm($serial_syp);
        if ($levelForm) {
            return response()->json($levelForm, 200);
        } else {
            return response()->json('No existe formulario configurado para el nivel', 404);
        }
    }

    //función para asignar o desasignar unidad de planificacion
    public function postSetPlanningUnitToSubject(Request $request) {
        $this->validate($request, [
            'serial_syp' => 'required',
            'serial_lpu' => 'required'
        ]);

        try {
            $result =$this->subject_planning_unit->setPlanningUnitToSubjectYearPlanning($request);
            if($result){
                return response()->json($result,200);
            }else{
                return response()->json('No se pudo asignar unidad de planificacion',200);
            }
        } catch (Exception $ex) {
            return response()->json('Existieron errores al asignar unidades de planificacion',500);
        }
    }

    public function postCreatePlanningUnit(Request $request) {
        $this->validate($request, [
            'description_put' => 'required',
            'is_ministry_put' => 'required',
            'serial_syp'=> 'required'
        ]);

        try {
            $planningUnit =$this->planning_unit->savePlanningUnit($request);
            if($planningUnit){
                $subjectYearPlanning=$this->subject_year_planning->getSubjectYearPlanning($request->get('serial_syp'));
                $subjectsGroupPlanning=$subjectYearPlanning->subjectGroupPlanning()->first();
                if($subjectsGroupPlanning){
                    if($subjectsGroupPlanning->serial_sbc){
                        $subject = $this->subject_course->getSubjectCourseInformation($subjectsGroupPlanning->serial_sbc);
                    }else if($subjectsGroupPlanning->serial_osb){
                        $subject = $this->optional_subject->getOptionalSubjectInformationBySerialOsb($subjectsGroupPlanning->serial_osb);
                    }
                    $levelPlanningUnit= $this->level_planning_unit->saveLevelPlanningUnit($subjectsGroupPlanning->serial_lvl,
                        $subjectsGroupPlanning->serial_set,$planningUnit->serial_put,$subject[0]['serial_aca']);

                    if($levelPlanningUnit && $planningUnit){

                        $data['serial_syp']=$request->get('serial_syp');
                        $data['serial_lpu']=$levelPlanningUnit->serial_lpu;
                        try {
                            $result =$this->subject_planning_unit->setPlanningUnitToSubjectYearPlanning($data);
                            if($result){
                                return response()->json($result,200);
                            }else{
                                return response()->json('No se pudo asignar unidad de planificacion',200);
                            }
                        } catch (Exception $ex) {
                            return response()->json('Existieron errores al asignar unidad de planificacion',500);
                        }
                    }else{
                        return response()->json('Existieron errores en la creacion de la unidad de planificacion');
                    }
                }else{
                    return response()->json('La planificaci&oacute;n anual no se ha creado correctamente',500);
                }
            }else{
                return response()->json('No se pudo crear unidad de planificacion',500);
            }
        } catch (Exception $ex) {
            return response()->json('Existieron errores al crear unidad de planificacion',500);
        }
    }


    /********************Configuración unidades de planificacion************************/

    //obtener detalle de unidad de planificacion
    public function getPlanningUnitDetail($serial_spu){
        $result=$this->subject_planning_unit->getSubjectPlanningUnitDetail($serial_spu);
        if($result){
            return response()->json($result,200);
        }else{
            return response()->json('No se encontro unidad de planificacion',200);
        }
    }


    //configurar fechas de unidades de planificacion
    public function postSetDatesSubjectUnit(Request $request) {
        $this->validate($request, [
            'start_date_spu' => 'required',
            'end_date_spu' => 'required',
            'serial_spu' => 'required'
        ]);
        try {
            $result =$this->subject_planning_unit->setDatesPlanningUnit($request);
            if($result){
                return response()->json($result,200);
            }else{
                return response()->json('No se pudo asignar las fechas a la unidad de planificacion',200);
            }
        } catch (Exception $ex) {
            return response()->json('Existieron errores al asignar las fechas a la unidades de planificacion',500);
        }
    }

    //objetivos especificos unidad de planificacion

    public function getSelectableSpecificObjectivesBySubjectUnit($serial_spu) {
        $listSpecificObjectives = $this->level_objective_unit->getLevelObjectiveUnitSelectable($serial_spu);
        if ($listSpecificObjectives) {
            return response()->json($listSpecificObjectives, 200);
        } else {
            return response()->json('No existen objetivos especificos configurados para la unidad de planificacion', 404);
        }
    }

    public function getSpecificObjectivesBySubjectUnit($serial_spu) {
        $listSpecificObjectives = $this->subject_planning_unit->getLevelObjectivesUnit($serial_spu);
        if ($listSpecificObjectives) {
            return response()->json($listSpecificObjectives, 200);
        } else {
            return response()->json('No existen objetivos especificos configurados para la unidad de planificacion', 404);
        }
    }

    //función para asignar o desasignar objetivos a la unidad de planificacion
    public function postSetSpecificObjectiveToSubjectUnit(Request $request) {
        $this->validate($request, [
            'serial_spu' => 'required',
            'serial_lou' => 'required'
        ]);

        try {
            $result =$this->subject_objective_unit->setSpecificObjectiveToSubjectUnit($request);
            if($result){
                return response()->json($result,200);
            }else{
                return response()->json('No se pudo asignar el objetivo especifico a la unidad de planificacion',200);
            }
        } catch (Exception $ex) {
            return response()->json('Existieron errores al asignar el objetivo especifico a la unidades de planificacion',500);
        }
    }

    public function postCreateSpecificObjectiveUnit(Request $request) {
        $this->validate($request, [
            'description_sou' => 'required',
            'is_ministry_sou' => 'required',
            'serial_spu'=> 'required'
        ]);

        try {
            $specificObjectiveUnit =$this->specific_objective_unit->saveSpecificObjectiveUnit($request);
            if($specificObjectiveUnit){
                $subjectPlanningUnit=$this->subject_planning_unit->getSubjectPlanningUnit($request->get('serial_spu'));
                if($subjectPlanningUnit){
                    $levelPlanningUnit= $this->level_planning_unit->getLevelPlanningUnit($subjectPlanningUnit->serial_lpu);
                    $levelObjectiveUnit= $this->level_objective_unit->saveLevelObjectiveUnit($levelPlanningUnit->serial_lvl,
                        $levelPlanningUnit->serial_set,$specificObjectiveUnit->serial_sou,$levelPlanningUnit->serial_aca);
                    if($levelObjectiveUnit){

                        $data['serial_spu']=$request->get('serial_spu');
                        $data['serial_lou']=$levelObjectiveUnit->serial_lou;
                        try {
                            $result =$this->subject_objective_unit->setSpecificObjectiveToSubjectUnit($data);
                            if($result){
                                return response()->json($result,200);
                            }else{
                                return response()->json('No se pudo asignar el objetivo a la unidad de planificacion',200);
                            }
                        } catch (Exception $ex) {
                            return response()->json('Existieron errores al asignar el objetivo a la unidad de planificacion',500);
                        }
                    }else{
                        return response()->json('Existieron errores en la creacion del objetivo especifico para unidades de planificacion');
                    }
                }else{
                    return response()->json('La unidad de planbificacion no existe',500);
                }
            }else{
                return response()->json('No se pudo crear el objetivo especifico para unidades de planificacion',500);
            }
        } catch (Exception $ex) {
            return response()->json('Existieron errores al crear el objetivo especifico para unidades de planificacion',500);
        }
    }

    //destrezas de unidad de planificacion
    public function getSelectableSkillsBySubjectUnit($serial_spu) {
        $listSkills = $this->level_unit_skills->getLevelUnitSkillSelectable($serial_spu);
        if ($listSkills) {
            return response()->json($listSkills, 200);
        } else {
            return response()->json('No existen destrezas configuradas para la unidad de planificacion', 404);
        }
    }

    public function getSkillsBySubjectUnit($serial_spu) {
        $listSkills = $this->subject_planning_unit->getLevelUnitSkill($serial_spu);
        if ($listSkills) {
            return response()->json($listSkills, 200);
        } else {
            return response()->json('No existen destrezas configuradas para la unidad de planificacion', 404);
        }
    }

    //función para asignar o desasignar objetivos a la unidad de planificacion
    public function postSetSkillToSubjectUnit(Request $request) {
        $this->validate($request, [
            'serial_spu' => 'required',
            'serial_lus' => 'required'
        ]);

        try {
            $result =$this->subject_unit_skills->setUnitSkillToSubjectUnit($request);
            if($result){
                return response()->json($result,200);
            }else{
                return response()->json('No se pudo asignar destreza a la unidad de planificacion',200);
            }
        } catch (Exception $ex) {
            return response()->json('Existieron errores al asignar la destreza a la unidades de planificacion',500);
        }
    }

    public function postCreateSkillUnit(Request $request) {
        $this->validate($request, [
            'description_pus' => 'required',
            'is_ministry_pus' => 'required',
            'serial_spu'=> 'required'
        ]);

        try {
            $skillUnit =$this->planning_unit_skills->savePlanningUnitSkill($request);
            if($skillUnit){
                $subjectPlanningUnit=$this->subject_planning_unit->getSubjectPlanningUnit($request->get('serial_spu'));
                if($subjectPlanningUnit){
                    $levelPlanningUnit= $this->level_planning_unit->getLevelPlanningUnit($subjectPlanningUnit->serial_lpu);
                    $levelUnitSkill= $this->level_unit_skills->saveLevelUnitSkill($levelPlanningUnit->serial_lvl,
                        $levelPlanningUnit->serial_set,$skillUnit->serial_pus,$levelPlanningUnit->serial_aca);
                    if($levelUnitSkill){

                        $data['serial_spu']=$request->get('serial_spu');
                        $data['serial_lus']=$levelUnitSkill->serial_lus;
                        try {
                            $result =$this->subject_unit_skills->setUnitSkillToSubjectUnit($data);
                            if($result){
                                return response()->json($result,200);
                            }else{
                                return response()->json('No se pudo asignar la destreza a la unidad de planificacion',200);
                            }
                        } catch (Exception $ex) {
                            return response()->json('Existieron errores al asignar la destreza a la unidad de planificacion',500);
                        }
                    }else{
                        return response()->json('Existieron errores en la creacion de la destreza para unidades de planificacion');
                    }
                }else{
                    return response()->json('La unidad de planbificacion no existe',500);
                }
            }else{
                return response()->json('No se pudo crear la destreza para unidades de planificacion',500);
            }
        } catch (Exception $ex) {
            return response()->json('Existieron errores al crear la destreza para unidades de planificacion',500);
        }
    }
    //Orientaciones Metodologicas de planificacion
    public function getSelectableMethodologicalOrientationBySubjectUnit($serial_spu) {
        $listOrientations = $this->level_methodological_orientation->getLevelMethodologicalOrientationUnitSelectable($serial_spu);
        if ($listOrientations) {
            return response()->json($listOrientations, 200);
        } else {
            return response()->json('No existen Orientaciones Metodologicas configuradas para la unidad de planificacion', 404);
        }
    }

    public function getMethodologicalOrientationBySubjectUnit($serial_spu) {
        $listOrientations = $this->subject_planning_unit->getLevelMethodologicalOrientation($serial_spu);
        if ($listOrientations) {
            return response()->json($listOrientations, 200);
        } else {
            return response()->json('No existen Orientaciones Metodologicas configuradas para la unidad de planificacion', 404);
        }
    }

    //función para asignar o desasignar objetivos a la unidad de planificacion
    public function postSetMethodologicalOrientationToSubjectUnit(Request $request) {
        $this->validate($request, [
            'serial_spu' => 'required',
            'serial_lmo' => 'required'
        ]);

        try {
            $result =$this->subject_methodological_orientation->setMethodologicalOrientationToSubjectUnit($request);
            if($result){
                return response()->json($result,200);
            }else{
                return response()->json('No se pudo asignar la Orientacione Metodologica a la unidad de planificacion',200);
            }
        } catch (Exception $ex) {
            return response()->json('Existieron errores al asignar la Orientacione Metodologica a la unidades de planificacion',500);
        }
    }

    public function postCreateMethodologicalOrientationUnit(Request $request) {
        $this->validate($request, [
            'description_mou' => 'required',
            'is_ministry_mou' => 'required',
            'serial_spu'=> 'required'
        ]);

        try {
            $methodologicalOrientation =$this->methodological_orientation_unit->saveMethodologicalOrientationUnit($request);
            if($methodologicalOrientation){
                $subjectPlanningUnit=$this->subject_planning_unit->getSubjectPlanningUnit($request->get('serial_spu'));
                if($subjectPlanningUnit){
                    $levelPlanningUnit= $this->level_planning_unit->getLevelPlanningUnit($subjectPlanningUnit->serial_lpu);
                    $levelMethodologicalOrientation= $this->level_methodological_orientation->saveLevelMethodologicalOrientationUnit($levelPlanningUnit->serial_lvl,
                        $levelPlanningUnit->serial_set,$methodologicalOrientation->serial_mou,$levelPlanningUnit->serial_aca);
                    if($levelMethodologicalOrientation){

                        $data['serial_spu']=$request->get('serial_spu');
                        $data['serial_lmo']=$levelMethodologicalOrientation->serial_lmo;
                        try {
                            $result =$this->subject_methodological_orientation->setMethodologicalOrientationToSubjectUnit($data);
                            if($result){
                                return response()->json($result,200);
                            }else{
                                return response()->json('No se pudo asignar la Orientacione Metodologica a la unidad de planificacion',200);
                            }
                        } catch (Exception $ex) {
                            return response()->json('Existieron errores al asignar la Orientacione Metodologica a la unidad de planificacion',500);
                        }
                    }else{
                        return response()->json('Existieron errores en la creacion de la Orientacione Metodologica para unidades de planificacion');
                    }
                }else{
                    return response()->json('La unidad de planificacion no existe',500);
                }
            }else{
                return response()->json('No se pudo crear la Orientacione Metodologica para unidades de planificacion',500);
            }
        } catch (Exception $ex) {
            return response()->json('Existieron errores al crear la Orientacione Metodologica para unidades de planificacion',500);
        }
    }



    //indicadores de evaluacion de planificacion
    public function getSelectableEvaluationIndicatorBySubjectUnit($serial_spu) {
        $listIndicators = $this->level_evaluation_indicators->getLevelEvaluationIndicatorSelectable($serial_spu);
        if ($listIndicators) {
            return response()->json($listIndicators, 200);
        } else {
            return response()->json('No existen indicadores de evaluacion configurados para la unidad de planificacion', 404);
        }
    }

    public function getEvaluationIndicatorBySubjectUnit($serial_spu) {
        $listIndicators = $this->subject_planning_unit->getLevelEvaluationIndicators($serial_spu);
        if ($listIndicators) {
            return response()->json($listIndicators, 200);
        } else {
            return response()->json('No existen indicadores de evaluacion configurados para la unidad de planificacion', 404);
        }
    }

    //función para asignar o desasignar objetivos a la unidad de planificacion
    public function postSetEvaluationIndicatorToSubjectUnit(Request $request) {
        $this->validate($request, [
            'serial_spu' => 'required',
            'serial_lei' => 'required'
        ]);

        try {
            $result =$this->subject_evaluation_indicators->setEvaluationIndicatorsToSubjectUnit($request);
            if($result){
                return response()->json($result,200);
            }else{
                return response()->json('No se pudo asignar el indicador de evaluacion a la unidad de planificacion',200);
            }
        } catch (Exception $ex) {
            return response()->json('Existieron errores al asignar el indicador de evaluacion a la unidades de planificacion',500);
        }
    }

    public function postCreateEvaluationIndicatorUnit(Request $request) {
        $this->validate($request, [
            'description_eiu' => 'required',
            'is_ministry_eiu' => 'required',
            'serial_spu'=> 'required'
        ]);

        try {
            $evaluationIndicator =$this->evaluation_indicators_unit->saveEvaluationIndicatorsUnit($request);
            if($evaluationIndicator){
                $subjectPlanningUnit=$this->subject_planning_unit->getSubjectPlanningUnit($request->get('serial_spu'));
                if($subjectPlanningUnit){
                    $levelPlanningUnit= $this->level_planning_unit->getLevelPlanningUnit($subjectPlanningUnit->serial_lpu);
                    $levelIndicatorsUnit= $this->level_evaluation_indicators->saveLevelEvaluationIndicator($levelPlanningUnit->serial_lvl,
                        $levelPlanningUnit->serial_set,$evaluationIndicator->serial_eiu,$levelPlanningUnit->serial_aca);
                    if($levelIndicatorsUnit){

                        $data['serial_spu']=$request->get('serial_spu');
                        $data['serial_lei']=$levelIndicatorsUnit->serial_lei;
                        try {
                            $result =$this->subject_evaluation_indicators->setEvaluationIndicatorsToSubjectUnit($data);
                            if($result){
                                return response()->json($result,200);
                            }else{
                                return response()->json('No se pudo asignar el indicador de evaluacion a la unidad de planificacion',200);
                            }
                        } catch (Exception $ex) {
                            return response()->json('Existieron errores al asignar el indicador de evaluacion a la unidad de planificacion',500);
                        }
                    }else{
                        return response()->json('Existieron errores en la creacion del indicador de evaluacion para unidades de planificacion');
                    }
                }else{
                    return response()->json('La unidad de planificacion no existe',500);
                }
            }else{
                return response()->json('No se pudo crear el indicador de evaluacion para unidades de planificacion',500);
            }
        } catch (Exception $ex) {
            return response()->json('Existieron errores al crear el indicador de evaluacion para unidades de planificacion',500);
        }
    }

    //ejes transversales de planificacion
    public function getSelectableTransverseBySubjectUnit($serial_spu) {
        $listTransverse = $this->level_transverse_unit->getLevelTransverseUnitSelectable($serial_spu);
        if ($listTransverse) {
            return response()->json($listTransverse, 200);
        } else {
            return response()->json('No existen ejes transversales configurados para la unidad de planificacion', 404);
        }
    }

    public function getTransverseBySubjectUnit($serial_spu) {
        $listTransverse = $this->subject_planning_unit->getLevelTransverseUnit($serial_spu);
        if ($listTransverse) {
            return response()->json($listTransverse, 200);
        } else {
            return response()->json('No existen ejes transversales configurados para la unidad de planificacion', 404);
        }
    }

    //función para asignar o desasignar objetivos a la unidad de planificacion
    public function postSetTransverseToSubjectUnit(Request $request) {
        $this->validate($request, [
            'serial_spu' => 'required',
            'serial_ltu' => 'required'
        ]);

        try {
            $result =$this->subject_transverse_unit->setTransverseUnitToSubjectUnit($request);
            if($result){
                return response()->json($result,200);
            }else{
                return response()->json('No se pudo asignar el eje transversal a la unidad de planificacion',200);
            }
        } catch (Exception $ex) {
            return response()->json('Existieron errores al asignar el eje transversal a la unidades de planificacion',500);
        }
    }

    public function postCreateTransverseUnit(Request $request) {
        $this->validate($request, [
            'description_txu' => 'required',
            'is_ministry_txu' => 'required',
            'serial_spu'=> 'required'
        ]);

        try {
            $transverseAxis =$this->transverse_axis_unit->saveTransverseAxisUnit($request);
            if($transverseAxis){
                $subjectPlanningUnit=$this->subject_planning_unit->getSubjectPlanningUnit($request->get('serial_spu'));
                if($subjectPlanningUnit){
                    $levelPlanningUnit= $this->level_planning_unit->getLevelPlanningUnit($subjectPlanningUnit->serial_lpu);
                    $levelTransverseUnit= $this->level_transverse_unit->saveLevelTransverseUnit($levelPlanningUnit->serial_lvl,
                        $levelPlanningUnit->serial_set,$transverseAxis->serial_txu,$levelPlanningUnit->serial_aca);
                    if($levelTransverseUnit){

                        $data['serial_spu']=$request->get('serial_spu');
                        $data['serial_ltu']=$levelTransverseUnit->serial_ltu;
                        try {
                            $result =$this->subject_transverse_unit->setTransverseUnitToSubjectUnit($data);
                            if($result){
                                return response()->json($result,200);
                            }else{
                                return response()->json('No se pudo asignar el eje transversal a la unidad de planificacion',200);
                            }
                        } catch (Exception $ex) {
                            return response()->json('Existieron errores al asignar el eje transversal a la unidad de planificacion',500);
                        }
                    }else{
                        return response()->json('Existieron errores en la creacion del eje transversal para unidades de planificacion');
                    }
                }else{
                    return response()->json('La unidad de planificacion no existe',500);
                }
            }else{
                return response()->json('No se pudo crear el eje transversal para unidades de planificacion',500);
            }
        } catch (Exception $ex) {
            return response()->json('Existieron errores al crear el eje transversal para unidades de planificacion',500);
        }
    }

    //estrategias metodologicas de planificacion
    public function getSelectableMethodologicalStrategiesBySubjectUnit($serial_spu) {
        $listStrategies = $this->level_strategies_unit->getLevelStrategiesUnitSelectable($serial_spu);
        if ($listStrategies) {
            return response()->json($listStrategies, 200);
        } else {
            return response()->json('No existen estrategias metodologicas configuradas para la unidad de planificacion', 404);
        }
    }

    public function getMethodologicalStrategiesBySubjectUnit($serial_spu) {
        $listStrategies = $this->subject_planning_unit->getLevelStrategiesUnit($serial_spu);
        if ($listStrategies) {
            return response()->json($listStrategies, 200);
        } else {
            return response()->json('No existen estrategias metodologicas configurados para la unidad de planificacion', 404);
        }
    }

    //función para asignar o desasignar objetivos a la unidad de planificacion
    public function postSetMethodologicalStrategiesToSubjectUnit(Request $request) {
        $this->validate($request, [
            'serial_spu' => 'required',
            'serial_lsu' => 'required'
        ]);

        try {
            $result =$this->subject_strategies_unit->setStrategiesToSubjectUnit($request);
            if($result){
                return response()->json($result,200);
            }else{
                return response()->json('No se pudo asignar la estrategia metodologica a la unidad de planificacion',200);
            }
        } catch (Exception $ex) {
            return response()->json('Existieron errores al asignar la estrategia metodologica a la unidades de planificacion',500);
        }
    }

    public function postCreateMethodologicalStrategiesUnit(Request $request) {
        $this->validate($request, [
            'description_msu' => 'required',
            'is_ministry_msu' => 'required',
            'serial_spu'=> 'required'
        ]);

        try {
            $methodologicalStrategies =$this->methodological_strategies_unit->saveMethodologicalStrategiesUnit($request);
            if($methodologicalStrategies){
                $subjectPlanningUnit=$this->subject_planning_unit->getSubjectPlanningUnit($request->get('serial_spu'));
                if($subjectPlanningUnit){
                    $levelPlanningUnit= $this->level_planning_unit->getLevelPlanningUnit($subjectPlanningUnit->serial_lpu);
                    $levelStrategiesUnit= $this->level_strategies_unit->saveLevelStrategiesUnit($levelPlanningUnit->serial_lvl,
                        $levelPlanningUnit->serial_set,$methodologicalStrategies->serial_msu,$levelPlanningUnit->serial_aca);
                    if($levelStrategiesUnit){

                        $data['serial_spu']=$request->get('serial_spu');
                        $data['serial_lsu']=$levelStrategiesUnit->serial_lsu;
                        try {
                            $result =$this->subject_strategies_unit->setStrategiesToSubjectUnit($data);
                            if($result){
                                return response()->json($result,200);
                            }else{
                                return response()->json('No se pudo asignar la estrategia metodologica a la unidad de planificacion',200);
                            }
                        } catch (Exception $ex) {
                            return response()->json('Existieron errores al asignar la estrategia metodologica a la unidad de planificacion',500);
                        }
                    }else{
                        return response()->json('Existieron errores en la creacion de la estrategia metodologica para unidades de planificacion');
                    }
                }else{
                    return response()->json('La unidad de planificacion no existe',500);
                }
            }else{
                return response()->json('No se pudo crear la estrategia metodologica para unidades de planificacion',500);
            }
        } catch (Exception $ex) {
            return response()->json('Existieron errores al crear la estrategia metodologica para unidades de planificacion',500);
        }
    }


    //Recursos de unidad de planificacion
    public function getSelectableResourceBySubjectUnit($serial_spu) {
        $listResources = $this->level_resources_unit->getLevelResourcesUnitSelectable($serial_spu);
        if ($listResources) {
            return response()->json($listResources, 200);
        } else {
            return response()->json('No existen recursos configurados para la unidad de planificacion', 404);
        }
    }

    public function getResourceBySubjectUnit($serial_spu) {
        $listResources = $this->subject_planning_unit->getLevelResourcesUnit($serial_spu);
        if ($listResources) {
            return response()->json($listResources, 200);
        } else {
            return response()->json('No existen recursos configurados para la unidad de planificacion', 404);
        }
    }

    //función para asignar o desasignar objetivos a la unidad de planificacion
    public function postSetResourceToSubjectUnit(Request $request) {
        $this->validate($request, [
            'serial_spu' => 'required',
            'serial_lru' => 'required'
        ]);

        try {
            $result =$this->subject_resources_unit->setResourceToSubjectUnit($request);
            if($result){
                return response()->json($result,200);
            }else{
                return response()->json('No se pudo asignar el recurso a la unidad de planificacion',200);
            }
        } catch (Exception $ex) {
            return response()->json('Existieron errores al asignar el recurso a la unidades de planificacion',500);
        }
    }

    public function postCreateResourceUnit(Request $request) {
        $this->validate($request, [
            'description_rpu' => 'required',
            'is_ministry_rpu' => 'required',
            'serial_spu'=> 'required'
        ]);

        try {
            $resource =$this->resources_planning_unit->saveResourcesPlanningUnit($request);
            if($resource){
                $subjectPlanningUnit=$this->subject_planning_unit->getSubjectPlanningUnit($request->get('serial_spu'));
                if($subjectPlanningUnit){
                    $levelPlanningUnit= $this->level_planning_unit->getLevelPlanningUnit($subjectPlanningUnit->serial_lpu);
                    $levelResourcesUnit= $this->level_resources_unit->saveLevelResourcesUnit($levelPlanningUnit->serial_lvl,
                        $levelPlanningUnit->serial_set,$resource->serial_rpu,$levelPlanningUnit->serial_aca);
                    if($levelResourcesUnit){

                        $data['serial_spu']=$request->get('serial_spu');
                        $data['serial_lru']=$levelResourcesUnit->serial_lru;
                        try {
                            $result =$this->subject_resources_unit->setResourceToSubjectUnit($data);
                            if($result){
                                return response()->json($result,200);
                            }else{
                                return response()->json('No se pudo asignar el recurso a la unidad de planificacion',200);
                            }
                        } catch (Exception $ex) {
                            return response()->json('Existieron errores al asignar el recurso a la unidad de planificacion',500);
                        }
                    }else{
                        return response()->json('Existieron errores en la creacion del recurso para unidades de planificacion');
                    }
                }else{
                    return response()->json('La unidad de planificacion no existe',500);
                }
            }else{
                return response()->json('No se pudo crear el recurso para unidades de planificacion',500);
            }
        } catch (Exception $ex) {
            return response()->json('Existieron errores al crear el recurso para unidades de planificacion',500);
        }
    }


    //Indicadores de logro de planificacion
    public function getSelectableAchievementIndicatorsBySubjectUnit($serial_spu) {
        $listIndicators = $this->level_indicators_unit->getLevelIndicatorsUnitSelectable($serial_spu);
        if ($listIndicators) {
            return response()->json($listIndicators, 200);
        } else {
            return response()->json('No existen indicadores configurados para la unidad de planificacion', 404);
        }
    }

    public function getAchievementIndicatorsBySubjectUnit($serial_spu) {
        $listIndicators = $this->subject_planning_unit->getLevelIndicatorsUnit($serial_spu);
        if ($listIndicators) {
            return response()->json($listIndicators, 200);
        } else {
            return response()->json('No existen indicadores configurados para la unidad de planificacion', 404);
        }
    }

    //función para asignar o desasignar objetivos a la unidad de planificacion
    public function postSetAchievementIndicatorsToSubjectUnit(Request $request) {
        $this->validate($request, [
            'serial_spu' => 'required',
            'serial_liu' => 'required'
        ]);

        try {
            $result =$this->subject_indicators_unit->setIndicatorsToSubjectUnit($request);
            if($result){
                return response()->json($result,200);
            }else{
                return response()->json('No se pudo asignar el indicador a la unidad de planificacion',200);
            }
        } catch (Exception $ex) {
            return response()->json('Existieron errores al asignar el indicador a la unidades de planificacion',500);
        }
    }

    public function postCreateAchievementIndicatorsUnit(Request $request) {
        $this->validate($request, [
            'description_aiu' => 'required',
            'is_ministry_aiu' => 'required',
            'serial_spu'=> 'required'
        ]);

        try {
            $achievement =$this->achievement_indicators_unit->saveAchievementIndicatorsUnit($request);
            if($achievement){
                $subjectPlanningUnit=$this->subject_planning_unit->getSubjectPlanningUnit($request->get('serial_spu'));
                if($subjectPlanningUnit){
                    $levelPlanningUnit= $this->level_planning_unit->getLevelPlanningUnit($subjectPlanningUnit->serial_lpu);
                    $levelAchievementUnit= $this->level_indicators_unit->saveLevelIndicatorsUnit($levelPlanningUnit->serial_lvl,
                        $levelPlanningUnit->serial_set,$achievement->serial_aiu,$levelPlanningUnit->serial_aca);
                    if($levelAchievementUnit){

                        $data['serial_spu']=$request->get('serial_spu');
                        $data['serial_liu']=$levelAchievementUnit->serial_liu;
                        try {
                            $result =$this->subject_indicators_unit->setIndicatorsToSubjectUnit($data);
                            if($result){
                                return response()->json($result,200);
                            }else{
                                return response()->json('No se pudo asignar el indicador a la unidad de planificacion',200);
                            }
                        } catch (Exception $ex) {
                            return response()->json('Existieron errores al asignar el indicador a la unidad de planificacion',500);
                        }
                    }else{
                        return response()->json('Existieron errores en la creacion del indicador para unidades de planificacion');
                    }
                }else{
                    return response()->json('La unidad de planificacion no existe',500);
                }
            }else{
                return response()->json('No se pudo crear el indicador para unidades de planificacion',500);
            }
        } catch (Exception $ex) {
            return response()->json('Existieron errores al crear el indicador para unidades de planificacion',500);
        }
    }

    //formularios unidades de planificacion
    public function getUnitPlanningFormDataBySubject($serial_put,$serial_spu,$serial_sbc,$serial_osb) {

        $formData = $this->unit_planning_form->getUnitPlanningFormDataBySubject($serial_put,$serial_spu,$serial_sbc,$serial_osb);
        if ($formData) {
            return response()->json($formData, 200);
        } else {
            return response()->json('No existen informacion en el formulario para la unidad de planificacion', 404);
        }
    }

    public function postSaveUnitForm(Request $request) {
        $this->validate($request, [
            'serial_put' => 'required'
        ]);
        $data=$request->all();
        try {
            $result =$unitPlanningFormData =$this->unit_planning_form->saveUnitPlanningForm($data);
            if($result){
                return response()->json($result,200);
            }else{
                return response()->json('No se pudo guardar el formulario de la unidad de planificacion',200);
            }
        } catch (Exception $ex) {
            return response()->json('Existieron errores al guardar el formulario de la unidad de planificacion',500);
        }

    }

    public function saveConfigUnitPlanner(Request $request) {
        $data=$request->all();
        $numberGroup = $this->subject_group_planning->getMaxGroupPlanning();
        try {
            $saveData['serial_scy'] = $data['serial_scy'];
            $saveData['serial_set'] = $data['serial_set'];
            $saveData['serial_lvl'] = $data['serial_lvl'];
            $saveData['number_group_sgp'] = $numberGroup['number_group_sgp'] + 1;
            if(isset($data['serial_sbc'])){
                $data['serial_sbc'] = explode(',',$data['serial_sbc']);
                foreach ($data['serial_sbc'] as $item){
                    $saveData['serial_sbc'] = $item;
                    $result = $this->subject_group_planning->saveSubjectGroupPlanning($saveData);
                }
            }
            if(isset($data['serial_osb'])){
                $saveOptionalData['serial_scy'] = $data['serial_scy'];
                $saveOptionalData['serial_set'] = $data['serial_set'];
                $saveOptionalData['serial_lvl'] = $data['serial_lvl'];
                $saveOptionalData['number_group_sgp'] = $numberGroup['number_group_sgp'] + 1;
                $data['serial_osb'] = explode(',',$data['serial_osb']);
                foreach ($data['serial_osb'] as $item){
                    $saveOptionalData['serial_osb'] = $item;
                    $result = $this->subject_group_planning->saveSubjectOptionalGroupPlanning($saveOptionalData);
                }
            }
            if($result){
                return response()->json('El grupo de planificacion se ha creado correctamente',200);
            }else{
                return response()->json('No se pudo crear el grupo de planificacion',200);
            }
        } catch (Exception $ex) {
            return response()->json('Existieron errores al crear el grupo de planificacion',500);
        }

    }

    public function saveSubjectConfig (Request $request) {
        $data=$request->all();
        $result = $this->subject_group_planning->subjectGroupPlanning($data);
        if($result){
            return response()->json($result,200);
        }else{
            return response()->json('No se pudo guardar el formulario de la unidad de planificacion',200);
        }
    }

    public function getUnitsPlanningWeek ($serial_spu,$serial_sbc,$serial_osb) {
        $serial_sbc = ($serial_sbc == 'null' ? null : $serial_sbc);
        $serial_osb = ($serial_osb == 'null' ? null : $serial_osb);
        $unitPlanningWeek = $this->unit_planning_week->getUnitsPlanningWeek($serial_spu,$serial_sbc,$serial_osb);
        if(count($unitPlanningWeek)){
            return response()->json($unitPlanningWeek);
        } else {
            return response()->json('No se ha creado la planificacion semanal',404);
        }
    }

    public function getUnitPlannerWeek ($serial_upw) {
        $unitPlanningWeek = $this->unit_planning_week->getUnitPlanningWeek($serial_upw);
        if(count($unitPlanningWeek)){
            return response()->json($unitPlanningWeek);
        } else {
            return response()->json('No se ha creado la planificacion semanal',404);
        }
    }

    public function postSaveUnitPlannerWeek (Request $request) {
        try {
            $data = $request->all();
            $data['serial_sbc'] = ($data['serial_sbc'] == '' ? null : $data['serial_sbc']);
            $data['serial_osb'] = ($data['serial_osb'] == '' ? null : $data['serial_osb']);
            $data['session'] = \GuzzleHttp\json_decode($data['session']);
            $savePlanningWeek = $this->unit_planning_week->saveUnitPlanningWeek($data);
            foreach ($data['session'] as $session) {
                $session = (array)$session;
                if(isset($session['serial_spw'])){
                    $saveSession = $this->session_planning_week->saveSessionWeek($session, $savePlanningWeek->serial_upw);
                } else {
                    $saveSession = $this->session_planning_week->saveSessionWeek($session, $savePlanningWeek->serial_upw);
                }
            }
            if ($saveSession) {
                return response()->json($saveSession, 200);
            } else {
                return response()->json('No se pudo guardar la planificacon semanal', 200);
            }
        } catch (Exception $ex) {
            return response()->json('Existieron errores al crear la unidad de planificacion semanal', 500);
        }
    }

    public function postDeleteSessionWeek(Request $request){
        try {
            $data = $request->all();
            $sessionWeek = $this->session_planning_week->deleteSessionWeek($data);
            if ($sessionWeek) {
                return response()->json($sessionWeek, 200);
            } else {
                return response()->json('No se pudo eliminar la sesion de la planificaion semanal', 200);
            }
        } catch (Exception $ex) {
            return response()->json('Existieron errores al eliminar la session de la unidad de planificacion semanal', 500);
        }
    }

    public function postNewPlanningWeek(Request $request){
        try {
            $data = $request->all();
            $savePlanningWeek = $this->unit_planning_week->saveNewPlanningWeek($data);
            if ($savePlanningWeek) {
                return response()->json($savePlanningWeek, 200);
            } else {
                return response()->json('No se pudo eliminar la sesion de la planificaion semanal', 200);
            }
        } catch (Exception $ex) {
            return response()->json('Existieron errores al eliminar la session de la unidad de planificacion semanal', 500);
        }
    }

    public function postYearPlanningReport(Request $request){
        try {
            $data = $request->all();
            if($data['serial_sbc'] != '' ){
                $infoYearPlanning = $this->subject_year_planning->getYearPlanningInfo($data['serial_syp'],$data['serial_sbc'],$data['serial_osb']);
                return response()->json($infoYearPlanning, 200);

            } elseif ($data['serial_osb'] != '') {
                $infoYearPlanning = $this->subject_year_planning->getYearPlanningInfoOpt($data['serial_syp'],$data['serial_sbc'],$data['serial_osb']);
                return response()->json($infoYearPlanning, 200);
            }

            /*$sessionWeek = $this->session_planning_week->deleteSessionWeek($data);
            if ($sessionWeek) {
                return response()->json($sessionWeek, 200);
            } else {
                return response()->json('No se pudo eliminar la sesion de la planificaion semanal', 200);
            }*/
        } catch (Exception $ex) {
            return response()->json('Existieron al generar el reporte de planificación anual', 500);
        }
    }

    public function postBlockPlanningReport(Request $request){
        try {
            $data = $request->all();
            $infoBlockPlanning = $this->subject_year_planning->getBlockPlanningInfo($data['serial_syp']);
            foreach ($infoBlockPlanning as $blockPlanning) {
                $objectives = $this->subject_planning_unit->getLevelObjectivesUnit($blockPlanning->serial_spu);
                $skills = $this->subject_planning_unit->getLevelUnitSkill($blockPlanning->serial_spu);
                $strategies = $this->subject_planning_unit->getLevelStrategiesUnit($blockPlanning->serial_spu);
                $indicators = $this->subject_planning_unit->getLevelEvaluationIndicators($blockPlanning->serial_spu);
                $blockPlanning['specific_objectives'] = $objectives;
                $blockPlanning['skills'] = $skills;
                $blockPlanning['strategies'] = $strategies;
                $blockPlanning['indicators'] = $indicators;
            }
            return response()->json($infoBlockPlanning, 200);

        } catch (Exception $ex) {
            return response()->json('Existieron al generar el reporte de planificación de bloque', 500);
        }
    }
}
