<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Repositories\StudentGuardianRepository;
use Laravel\Lumen\Routing\Controller as BaseController;

/**
 * Controlador para StudentGuardian
 * @since   2018-04-04
 * @author  Erick Vaca <epvaca@rutatec.com>
 *
 * @edit    2018-04-04<br />
 *          Erick Vaca <epvaca@rutatec.com><br /><br/>
 *          Creación del controlador<br/>
 *          #edit1
 */
class StudentGuardianController extends BaseController {

    protected $studentGuardian;

    /**
     * Constructor
     * @since   2018-04-04
     * @param   StudentGuardianRepository  $studentGuardian repositorio
     * @author   Erick Vaca <epvaca@rutatec.com><br /><br/>
     *
     */
    public function __construct(StudentGuardianRepository $studentGuardian){
        $this->studentGuardian = $studentGuardian;
    }

    /**
     * Método para obtener materias
     * @since   2018-04-04
     * @param   integer $serial_grd guardian
     * @param   integer serial_scy año lectivo     
     * @author   Erick Vaca <epvaca@rutatec.com><br /><br/>
     * @return  json resultado
     *
     */
    public function getStudentsByGuardianInSchoolYear($serial_grd, $serial_scy){

        $students = $this->studentGuardian->getStudentsByGuardianInSchoolYear($serial_grd, $serial_scy);

        return response()->json($students);
        
    }


}