<?php
/**
 * Controlador para métodos sobre zona/sector.
 * User: Henry Vivanco <hvvivanco@rutatec.com>
 * Date: 21/1/2019
 * Time: 15:44
 */

namespace App\Http\Controllers;


use App\Repositories\ZoneAdressRepositoy;
use Illuminate\Http\Request;

class ZoneAddressController extends Controller
{
    protected $zone;

    public function __construct(ZoneAdressRepositoy $zone)
    {
        $this->zone = $zone;
    }

    public function getZoneAddress(Request $request){
        $this->validate($request, [
            'serial_parish' => 'required',
        ]);
        $serialParish = $request->get('serial_parish');
        $zoneAddress = $this->zone->getZoneAddress($serialParish);
        return response()->json($zoneAddress);
    }
}