<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;

/**
 * Modelo para Subperiod
 * @since   2018-04-05
 * @author  Erick Vaca <epvaca@rutatec.com>
 *
 * @edit    2018-04-05<br />
 *          Erick Vaca <epvaca@rutatec.com><br /><br/>
 *          Creación del archivo<br/>
 *          #edit1
 */
class Period extends Model {

    public $timestamps = false;
    protected $table = 'period';
    protected $primaryKey = 'serial_prd';
    
    public function subperiods() {
        return $this->hasMany(\App\Models\Subperiod::class,'serial_prd')->where('status_sbp','=','ACTIVE');
    }
    
     public function periodGroupYear() {
        return $this->belongsTo(\App\Models\PeriodGroupYear::class,'serial_pgy')->where('status_pgy','=','ACTIVE');
    }

}
