<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;

/**
 * Modelo para SchoolYear
 * @since   2017-07-09
 * @author  Erick Vaca <epvaca@rutatec.com>
 *
 * @edit    2017-07-09<br />
 *          Erick Vaca <epvaca@rutatec.com><br /><br/>
 *          Creación del archivo<br/>
 *          #edit1
 */
class SchoolYear extends Model {

    protected $table = 'school_year';
    protected $primaryKey = 'serial_scy';
    protected $fillable = array('start_date_scy', 'end_date_scy','status_scy',
    	'name_scy');
    public $timestamps = false;
    public function periods() {
        return $this->hasMany(\App\Models\Period::class,'serial_pgy')->where('status_prd','=','ACTIVE');
    }
    
    
    /**
     * Relacion con la tabla qualitative_equivalence
     * @author Sebastian Aleman <jsaleman@rutatec.com>
     * @since  2016-12-01
     * @return mixed
     */
    public function qualitativeEquivalences() {
        return $this->hasMany(\App\Models\QualitativeEquivalence::class, 'serial_scy');
    }
    /**
     * Relacion con la tabla observaciones
     * @author Sebastian Aleman <flbenalcazar@rutatec.com>
     * @since  2019-08-18
     * @return mixed
     */
    public function observations() {
        return $this->hasMany(\App\Models\Observation::class, 'serial_scy');
    }

}
