<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;



/**
 * Modelo para Student
 * @since   2018-04-05
 * @author  Erick Vaca <epvaca@rutatec.com>
 *
 * @edit    2018-04-05<br />
 *          Erick Vaca <epvaca@rutatec.com><br /><br/>
 *          Creación del archivo<br/>
 *          #edit1
 */


class Student extends Model {

    public $timestamps = false;
    protected $table = 'student';
    protected $primaryKey = 'serial_std';

    //Relacion estudiante - representante
    public function guardians() {
        return $this->belongsToMany(\App\Models\Guardian::class, 'student_guardian', 'serial_std', 'serial_grd')
            ->where('guardian.status_grd', '=', 'ACTIVE')
            ->where('status_stg','=','ACTIVE')
            ->orderBy('guardian.first_name_grd')
            ->orderBy('guardian.last_name_grd');
    }
    
}
