<?php
/**
 * Created by PhpStorm.
 * User: jaserrano
 */

namespace App\Models;

use Illuminate\Database\Eloquent\Model;

class SubjectPlanningUnit extends Model {

    public $timestamps = false;
    protected $table = 'subject_planning_unit';
    protected $primaryKey = 'serial_spu';

    function levelObjectivesUnit(){
        return $this->belongsToMany('App\Models\LevelObjectiveUnit','subject_objective_unit','serial_spu','serial_lou')
            ->where('status_lou','=','ACTIVE');
    }
    function levelUnitSkill(){
        return $this->belongsToMany('App\Models\LevelUnitSkill','subject_unit_skills','serial_spu','serial_lus')
            ->where('status_lus','=','ACTIVE');
    }
    function levelMethodologicalOrientationUnit(){
        return $this->belongsToMany('App\Models\LevelMethodologicalOrientationUnit','subject_methodological_orientation','serial_spu','serial_lmo')
            ->where('status_lmo','=','ACTIVE');
    }
    function levelEvaluationIndicators(){
        return $this->belongsToMany('App\Models\LevelEvaluationIndicators','subject_evaluation_indicators','serial_spu','serial_lei')
            ->where('status_lei','=','ACTIVE');
    }
    function levelTransverseUnit(){
        return $this->belongsToMany('App\Models\LevelTransverseUnit','subject_transverse_unit','serial_spu','serial_ltu')
            ->where('status_ltu','=','ACTIVE');
    }
    function levelStrategiesUnit(){
        return $this->belongsToMany('App\Models\LevelStrategiesUnit','subject_strategies_unit','serial_spu','serial_lsu')
            ->where('status_lsu','=','ACTIVE');
    }
    function levelResourcesUnit(){
        return $this->belongsToMany('App\Models\LevelResourcesUnit','subject_resources_unit','serial_spu','serial_lru')
            ->where('status_lru','=','ACTIVE');
    }
    function levelIndicatorsUnit(){
        return $this->belongsToMany('App\Models\LevelIndicatorsUnit','subject_indicators_unit','serial_spu','serial_liu')
            ->where('status_liu','=','ACTIVE');
    }

    function unitPlanningWeek(){
        return $this->hasMany('App\Models\UnitPlanningWeek','serial_spu')
            ->where('status_upw', '=', 'ACTIVE');
    }

}