<?php
/**
 * Created by PhpStorm.
 * User: Henry Vivanco <hvvivanco@rutatec.com>
 * Date: 5/1/2020
 * Time: 13:43
 */

namespace App\Repositories;


use App\Models\ApplicantGuardianStudent;
use Illuminate\Database\Eloquent\Model;

class ApplicantGuardianStudentRepository extends Model
{
    protected $applicantGuardianStudent;

    public function __construct(ApplicantGuardianStudent $applicantGuardianStudent)
    {
        $this->applicantGuardianStudent = $applicantGuardianStudent;
    }

    public function saveApplicantGuardianStudent($applicantGuardianStudent){

        $result = new ApplicantGuardianStudent($applicantGuardianStudent);
        $result->save();
        return $result;

    }

    public function getGuardianStudent($serial_ast, $type_guardian){
        $result = ApplicantGuardianStudent::where('serial_ast','=',$serial_ast)
            ->where('relationship_ast','=',$type_guardian)
            ->join('applicant_guardian as agd','agd.serial_agd','=','applicant_guardian_student.serial_agd')
            ->select('agd.*','applicant_guardian_student.relationship_ast')
            ->first();
        return $result;
    }

}