<?php

namespace App\Repositories;

abstract class BaseRepository {

    protected $modelClass;
    
    protected function newQuery() {
        return app($this->modelClass)->newQuery();
    }

    public function lists($column, $key = null) {
        return $this->newQuery()->pluck($column, $key);
    }

    public function findById($id, $fail = true) {
        if ($fail) {
            return $this->newQuery()->findOrFail($id);
        }
        return $this->newQuery()->find($id);
    }

    protected function doQueryFirst($query = null) {
        if (is_null($query)) {
            $query = $this->newQuery();
        }
        return $query->first();
    }
    
     protected function doQueryGet($query = null) {
        if (is_null($query)) {
            $query = $this->newQuery();
        }
        return $query->get();
    }

}
