<?php
/**
 * Repositorio para consulta de cantones.
 * User: Henry Vivanco <hvvivanco@rutatec.com>
 * Date: 21/1/2019
 * Time: 15:33
 */

namespace App\Repositories;


use App\Models\Counties;

class CountiesRepository extends BaseRepository
{
    protected $counties;

    public function __construct(Counties $counties)
    {
        $this->counties = $counties;
    }

    /**
     * Método para obtener cantones(condados) según el estado
     * @author Henry Vivanco <hvvivanco@rutatec.com>
     * @since  2019-01-21
     * @return array $countries
     */
    public function getCounties($serialState){
        $counties = Counties::where('status_cnt','=','ACTIVE')
            ->where('serial_ste','=',$serialState)
            ->get(['serial_cnt','name_cnt']);
        return $counties;
    }


}