<?php

namespace App\Repositories;

use App\Models\Guardian;
use App\Repositories\BaseRepository;

class GuardianRepository extends BaseRepository {

    protected $modelClass = Guardian::class;
    protected $guardian;
    protected $studentYear;
    protected $schoolYear;

    //Declaración del constructor
    public function __construct(Guardian $guardian,StudentYearRepository $studentYear, SchoolYearRepository $schoolYear) {
        $this->guardian = $guardian;
        $this->studentYear=$studentYear;
        $this->schoolYear=$schoolYear;
    }

    
    public function getGuardianInfo($serial_usr){
        $guardian=$this->newQuery();
        $guardian->join('user','user.serial_usr','=','guardian.serial_usr');
        $guardian->where('user.serial_usr','=',$serial_usr);
        $guardian->where('status_grd','=','ACTIVE');
        $guardian->selectRaw('guardian.*,user.status_usr');
        return $this->doQueryFirst($guardian);
    }

}
