<?php

namespace App\Repositories;

use App\Models\LevelEvaluationIndicators;
use App\Models\LevelPlanningUnit;
use App\Models\SubjectPlanningUnit;


class LevelEvaluationIndicatorsRepository extends BaseRepository {

    protected $modelClass = LevelEvaluationIndicators::class;

    protected $levelEvaluationIndicator;


    public function __construct(LevelEvaluationIndicators $levelEvaluationIndicator) {
        $this->levelEvaluationIndicator = $levelEvaluationIndicator;
    }
    public function getLevelEvaluationIndicatorSelectable($serial_spu) {
        $levelEvaluationIndicator = $this->newQuery();
        $subjectPlanningUnit = SubjectPlanningUnit::where('serial_spu', '=', $serial_spu)
            ->where('status_spu', '=', 'ACTIVE')
            ->first();
        $levelPlanningUnit = LevelPlanningUnit::where('serial_lpu', '=', $subjectPlanningUnit->serial_lpu)
            ->where('status_lpu', '=', 'ACTIVE')
            ->first();
        $levelEvaluationIndicator->where('selectable', '=', 'YES')
            ->where('serial_aca', '=', $levelPlanningUnit->serial_aca)
            ->where('serial_lvl', '=',  $levelPlanningUnit->serial_lvl)
            ->where('serial_set', '=',  $levelPlanningUnit->serial_set)
            ->where('status_lei', '=', 'ACTIVE')
            ->with('evaluationIndicatorsUnit')
            ->with(array('subjectEvaluationIndicators'=>function($query) use ($serial_spu){
                $query->where('serial_spu','=',$serial_spu);
            }));
        $levelEvaluationIndicators= $this->doQueryGet($levelEvaluationIndicator);
        if(sizeof($levelEvaluationIndicators)>0){
            foreach ($levelEvaluationIndicators as $key=>$levelEvaluationIndicatorObj){
                $result[$key]['serial_lei']=$levelEvaluationIndicatorObj->serial_lei;
                $result[$key]['description_eiu']=$levelEvaluationIndicatorObj->evaluationIndicatorsUnit->description_eiu;
                $result[$key]['is_ministry_eiu']=$levelEvaluationIndicatorObj->evaluationIndicatorsUnit->is_ministry_eiu;
                $result[$key]['assigned']=$levelEvaluationIndicatorObj->subjectEvaluationIndicators!=null?true:false;
            }
        }else{
            $result= false;
        }
        return $result;
    }


    function saveLevelEvaluationIndicator($serial_lvl,$serial_set,$serial_eiu,$serial_aca){
        $levelEvaluationIndicator = new LevelEvaluationIndicators();
        $levelEvaluationIndicator->serial_lvl=$serial_lvl;
        $levelEvaluationIndicator->serial_set=$serial_set;
        $levelEvaluationIndicator->serial_eiu=$serial_eiu;
        $levelEvaluationIndicator->selectable='YES';
        $levelEvaluationIndicator->status_lei='ACTIVE';
        $levelEvaluationIndicator->serial_aca=$serial_aca;
        $levelEvaluationIndicator->save();
        return $levelEvaluationIndicator;
    }


}
