<?php

namespace App\Repositories;

use App\Models\LevelMethodologicalOrientationUnit;
use App\Models\LevelPlanningUnit;
use App\Models\SubjectPlanningUnit;


class LevelMethodologicalOrientationUnitRepository extends BaseRepository {

    protected $modelClass = LevelMethodologicalOrientationUnit::class;

    protected $levelMethodologicalOrientationUnit;


    public function __construct(LevelMethodologicalOrientationUnit $levelMethodologicalOrientationUnit) {
        $this->levelMethodologicalOrientationUnit = $levelMethodologicalOrientationUnit;
    }
    public function getLevelMethodologicalOrientationUnitSelectable($serial_spu) {
        $levelMethodologicalOrientationUnit = $this->newQuery();
        $subjectPlanningUnit = SubjectPlanningUnit::where('serial_spu', '=', $serial_spu)
            ->where('status_spu', '=', 'ACTIVE')
            ->first();
        $levelPlanningUnit = LevelPlanningUnit::where('serial_lpu', '=', $subjectPlanningUnit->serial_lpu)
            ->where('status_lpu', '=', 'ACTIVE')
            ->first();
        $levelMethodologicalOrientationUnit->where('selectable', '=', 'YES')
            ->where('serial_aca', '=', $levelPlanningUnit->serial_aca)
            ->where('serial_lvl', '=',  $levelPlanningUnit->serial_lvl)
            ->where('serial_set', '=',  $levelPlanningUnit->serial_set)
            ->where('status_lmo', '=', 'ACTIVE')
            ->with('methodologicalOrientationUnit')
            ->with(array('subjectMethodologicalOrientation'=>function($query) use ($serial_spu){
                $query->where('serial_spu','=',$serial_spu);
            }));
        $levelMethodologicalOrientationUnits= $this->doQueryGet($levelMethodologicalOrientationUnit);
        if(sizeof($levelMethodologicalOrientationUnits)>0){
            foreach ($levelMethodologicalOrientationUnits as $key=>$levelMethodologicalOrientationUnitObj){
                $result[$key]['serial_lmo']=$levelMethodologicalOrientationUnitObj->serial_lmo;
                $result[$key]['description_mou']=$levelMethodologicalOrientationUnitObj->methodologicalOrientationUnit->description_mou;
                $result[$key]['is_ministry_mou']=$levelMethodologicalOrientationUnitObj->methodologicalOrientationUnit->is_ministry_mou;
                $result[$key]['assigned']=$levelMethodologicalOrientationUnitObj->subjectMethodologicalOrientation!=null?true:false;
            }
        }else{
            $result= false;
        }
        return $result;
    }


    function saveLevelMethodologicalOrientationUnit($serial_lvl,$serial_set,$serial_mou,$serial_aca){
        $levelMethodologicalOrientationUnit = new LevelMethodologicalOrientationUnit();
        $levelMethodologicalOrientationUnit->serial_lvl=$serial_lvl;
        $levelMethodologicalOrientationUnit->serial_set=$serial_set;
        $levelMethodologicalOrientationUnit->serial_mou=$serial_mou;
        $levelMethodologicalOrientationUnit->selectable='YES';
        $levelMethodologicalOrientationUnit->status_lmo='ACTIVE';
        $levelMethodologicalOrientationUnit->serial_aca=$serial_aca;
        $levelMethodologicalOrientationUnit->save();
        return $levelMethodologicalOrientationUnit;
    }


}
