<?php

namespace App\Repositories;

use App\Models\LevelObjectiveUnit;
use App\Models\LevelPlanningUnit;
use App\Models\SubjectPlanningUnit;


class LevelObjectiveUnitRepository extends BaseRepository {

    protected $modelClass = LevelObjectiveUnit::class;

    protected $levelObjectiveUnit;


    public function __construct(LevelObjectiveUnit $levelObjectiveUnit) {
        $this->levelObjectiveUnit = $levelObjectiveUnit;
    }
    public function getLevelObjectiveUnitSelectable($serial_spu) {
        $levelObjectiveUnit = $this->newQuery();
        $subjectPlanningUnit = SubjectPlanningUnit::where('serial_spu', '=', $serial_spu)
            ->where('status_spu', '=', 'ACTIVE')
            ->first();
        $levelPlanningUnit = LevelPlanningUnit::where('serial_lpu', '=', $subjectPlanningUnit->serial_lpu)
            ->where('status_lpu', '=', 'ACTIVE')
            ->first();
        $levelObjectiveUnit->where('selectable', '=', 'YES')
            ->where('serial_aca', '=', $levelPlanningUnit->serial_aca)
            ->where('serial_lvl', '=',  $levelPlanningUnit->serial_lvl)
            ->where('serial_set', '=',  $levelPlanningUnit->serial_set)
            ->where('status_lou', '=', 'ACTIVE')
            ->with('specificObjectivesUnit')
            ->with(array('subjectObjectivesUnit'=>function($query) use ($serial_spu){
                $query->where('serial_spu','=',$serial_spu);
            }));
        $levelObjectiveUnits= $this->doQueryGet($levelObjectiveUnit);
        if(sizeof($levelObjectiveUnits)>0){
            foreach ($levelObjectiveUnits as $key=>$levelObjectiveUnitObj){
                $result[$key]['serial_lou']=$levelObjectiveUnitObj->serial_lou;
                $result[$key]['description_sou']=$levelObjectiveUnitObj->specificObjectivesUnit->description_sou;
                $result[$key]['is_ministry_sou']=$levelObjectiveUnitObj->specificObjectivesUnit->is_ministry_sou;
                $result[$key]['assigned']=$levelObjectiveUnitObj->subjectObjectivesUnit!=null?true:false;
            }
        }else{
            $result= false;
        }
        return $result;
    }


    function saveLevelObjectiveUnit($serial_lvl,$serial_set,$serial_sou,$serial_aca){
        $levelObjectiveUnit = new LevelObjectiveUnit();
        $levelObjectiveUnit->serial_lvl=$serial_lvl;
        $levelObjectiveUnit->serial_set=$serial_set;
        $levelObjectiveUnit->serial_sou=$serial_sou;
        $levelObjectiveUnit->selectable='YES';
        $levelObjectiveUnit->status_lou='ACTIVE';
        $levelObjectiveUnit->serial_aca=$serial_aca;
        $levelObjectiveUnit->save();
        return $levelObjectiveUnit;
    }


}
