<?php

namespace App\Repositories;

use App\Models\LevelSpecificObjectives;
use App\Models\OptionalSubject;
use App\Models\SubjectCourse;


class LevelSpecificObjectivesRepository extends BaseRepository {

    protected $modelClass = LevelSpecificObjectives::class;

    protected $levelSpecificObjectives;


    public function __construct(LevelSpecificObjectives $levelSpecificObjectives) {
        $this->levelSpecificObjectives = $levelSpecificObjectives;
    }


    public function getLevelSpecificObjectivesSelectable($serial_sbc, $serial_osb, $serial_lvl, $serial_set) {
        $levelSpecificObjectives = $this->newQuery();
        if (strtoupper($serial_sbc) != 'NULL') {
            $subjectCourse = SubjectCourse::where('serial_sbc', '=', $serial_sbc)
                ->where('status_sbc', '=', 'ACTIVE')
                ->first();
            $levelSpecificObjectives->where('serial_aca', '=', $subjectCourse->serial_aca);
        }
        if (strtoupper($serial_osb) != 'NULL') {
            $optionalSubject = OptionalSubject::where('serial_osb', '=', $serial_osb)
                ->where('status_osb', '=', 'ACTIVE')
                ->first();
            $levelSpecificObjectives->where('serial_aca', '=', $optionalSubject->serial_aca);
        }
        $levelSpecificObjectives->where('selectable', '=', 'YES')
            ->where('serial_lvl', '=', $serial_lvl)
            ->where('serial_set', '=', $serial_set)
            ->where('status_lso', '=', 'ACTIVE')
            ->with('specificObjectives')
            ->with('subjectSpecificObjectives');
        $levelSpecificObjectives= $this->doQueryGet($levelSpecificObjectives);
        if(sizeof($levelSpecificObjectives)>0) {
            foreach ($levelSpecificObjectives as $key => $levelGeneralObjective) {
                $result[$key]['serial_lso'] = $levelGeneralObjective->serial_lso;
                $result[$key]['description_pso'] = $levelGeneralObjective->specificObjectives->description_pso;
                $result[$key]['is_ministry_objective'] = $levelGeneralObjective->specificObjectives->is_ministry_objective;
                $result[$key]['assigned'] = $levelGeneralObjective->subjectSpecificObjectives != null ? true : false;
            }
        }else{
            $result = false;
        }
        usort($result, function($a, $b)
        {
            return strcmp($a['description_pso'], $b['description_pso']);
        });
        return $result;
    }


    function saveLevelSpecificObjective($serial_lvl,$serial_set,$serial_pso,$serial_aca){
        $levelSpecificObjectives = new LevelSpecificObjectives();
        $levelSpecificObjectives->serial_lvl=$serial_lvl;
        $levelSpecificObjectives->serial_set=$serial_set;
        $levelSpecificObjectives->serial_pso=$serial_pso;
        $levelSpecificObjectives->selectable='YES';
        $levelSpecificObjectives->status_lso='ACTIVE';
        $levelSpecificObjectives->serial_aca=$serial_aca;
        $levelSpecificObjectives->save();
        return $levelSpecificObjectives;
    }


}
