<?php

namespace App\Repositories;

use App\Models\LevelTransverseAxis;
use App\Models\OptionalSubject;
use App\Models\SubjectCourse;


class LevelTransverseAxisRepository extends BaseRepository {

    protected $modelClass = LevelTransverseAxis::class;

    protected $levelTransverseAxes;


    public function __construct(LevelTransverseAxis $levelTransverseAxes) {
        $this->levelTransverseAxes = $levelTransverseAxes;
    }
    public function getLevelTransverseAxisSelectable($serial_sbc, $serial_osb, $serial_lvl, $serial_set) {
        $levelTransverseAxes = $this->newQuery();
        if (strtoupper($serial_sbc) != 'NULL') {
            $subjectCourse = SubjectCourse::where('serial_sbc', '=', $serial_sbc)
                ->where('status_sbc', '=', 'ACTIVE')
                ->first();
            $levelTransverseAxes->where('serial_aca', '=', $subjectCourse->serial_aca);
        }
        if (strtoupper($serial_osb) != 'NULL') {
            $optionalSubject = OptionalSubject::where('serial_osb', '=', $serial_osb)
                ->where('status_osb', '=', 'ACTIVE')
                ->first();
            $levelTransverseAxes->where('serial_aca', '=', $optionalSubject->serial_aca);
        }
        $levelTransverseAxes->where('selectable', '=', 'YES')
            ->where('serial_lvl', '=', $serial_lvl)
            ->where('serial_set', '=', $serial_set)
            ->where('status_ltx', '=', 'ACTIVE')
            ->with('transverseAxis')
            ->with('subjectTransverseAxis');
        $levelTransverseAxes= $this->doQueryGet($levelTransverseAxes);
        if(sizeof($levelTransverseAxes)>0){
            foreach ($levelTransverseAxes as $key=>$levelTransverseAxis){
                $result[$key]['serial_ltx']=$levelTransverseAxis->serial_ltx;
                $result[$key]['description_ptx']=$levelTransverseAxis->transverseAxis->description_ptx;
                $result[$key]['is_ministry_ptx']=$levelTransverseAxis->transverseAxis->is_ministry_ptx;
                $result[$key]['assigned']=$levelTransverseAxis->subjectTransverseAxis!=null?true:false;
            }
        }else{
            $result= false;
        }
        usort($result, function($a, $b)
        {
            return strcmp($a['description_ptx'], $b['description_ptx']);
        });
        return $result;
    }


    function saveLevelTransverseAxis($serial_lvl,$serial_set,$serial_ptx,$serial_aca){
        $levelTransverseAxes = new levelTransverseAxis();
        $levelTransverseAxes->serial_lvl=$serial_lvl;
        $levelTransverseAxes->serial_set=$serial_set;
        $levelTransverseAxes->serial_ptx=$serial_ptx;
        $levelTransverseAxes->selectable='YES';
        $levelTransverseAxes->status_ltx='ACTIVE';
        $levelTransverseAxes->serial_aca=$serial_aca;
        $levelTransverseAxes->save();
        return $levelTransverseAxes;
    }


}
