<?php

namespace App\Repositories;

use App\Models\LevelTransverseUnit;
use App\Models\LevelPlanningUnit;
use App\Models\SubjectPlanningUnit;


class LevelTransverseUnitRepository extends BaseRepository {

    protected $modelClass = LevelTransverseUnit::class;

    protected $levelTransverseUnit;


    public function __construct(LevelTransverseUnit $levelTransverseUnit) {
        $this->levelEvaluationIndicator = $levelTransverseUnit;
    }
    public function getLevelTransverseUnitSelectable($serial_spu) {
        $levelTransverseUnit = $this->newQuery();
        $subjectPlanningUnit = SubjectPlanningUnit::where('serial_spu', '=', $serial_spu)
            ->where('status_spu', '=', 'ACTIVE')
            ->first();
        $levelPlanningUnit = LevelPlanningUnit::where('serial_lpu', '=', $subjectPlanningUnit->serial_lpu)
            ->where('status_lpu', '=', 'ACTIVE')
            ->first();
        $levelTransverseUnit->where('selectable', '=', 'YES')
            ->where('serial_aca', '=', $levelPlanningUnit->serial_aca)
            ->where('serial_lvl', '=',  $levelPlanningUnit->serial_lvl)
            ->where('serial_set', '=',  $levelPlanningUnit->serial_set)
            ->where('status_ltu', '=', 'ACTIVE')
            ->with('transverseAxisUnit')
            ->with(array('subjectTransverseUnit'=>function($query) use ($serial_spu){
                $query->where('serial_spu','=',$serial_spu);
            }));
        $levelTransverseUnits= $this->doQueryGet($levelTransverseUnit);
        if(sizeof($levelTransverseUnits)>0){
            foreach ($levelTransverseUnits as $key=>$levelTransverseUnitObj){
                $result[$key]['serial_ltu']=$levelTransverseUnitObj->serial_ltu;
                $result[$key]['description_txu']=$levelTransverseUnitObj->transverseAxisUnit->description_txu;
                $result[$key]['is_ministry_txu']=$levelTransverseUnitObj->transverseAxisUnit->is_ministry_txu;
                $result[$key]['assigned']=$levelTransverseUnitObj->subjectTransverseUnit!=null?true:false;
            }
        }else{
            $result= false;
        }
        return $result;
    }


    function saveLevelTransverseUnit($serial_lvl,$serial_set,$serial_txu,$serial_aca){
        $levelTransverseUnit = new LevelTransverseUnit();
        $levelTransverseUnit->serial_lvl=$serial_lvl;
        $levelTransverseUnit->serial_set=$serial_set;
        $levelTransverseUnit->serial_txu=$serial_txu;
        $levelTransverseUnit->selectable='YES';
        $levelTransverseUnit->status_ltu='ACTIVE';
        $levelTransverseUnit->serial_aca=$serial_aca;
        $levelTransverseUnit->save();
        return $levelTransverseUnit;
    }


}
