<?php

namespace App\Repositories;

use App\Models\LevelUnitSkill;
use App\Models\LevelPlanningUnit;
use App\Models\SubjectPlanningUnit;


class LevelUnitSkillRepository extends BaseRepository {

    protected $modelClass = LevelUnitSkill::class;

    protected $levelUnitSkill;


    public function __construct(LevelUnitSkill $levelUnitSkill) {
        $this->levelUnitSkill = $levelUnitSkill;
    }
    public function getLevelUnitSkillSelectable($serial_spu) {
        $levelUnitSkill = $this->newQuery();
        $subjectPlanningUnit = SubjectPlanningUnit::where('serial_spu', '=', $serial_spu)
            ->where('status_spu', '=', 'ACTIVE')
            ->first();
        $levelPlanningUnit = LevelPlanningUnit::where('serial_lpu','=',$subjectPlanningUnit->serial_lpu)
            ->where('status_lpu', '=', 'ACTIVE')
            ->first();
        $levelUnitSkill->where('selectable', '=', 'YES')
            ->where('serial_aca', '=', $levelPlanningUnit->serial_aca)
            ->where('serial_lvl', '=',  $levelPlanningUnit->serial_lvl)
            ->where('serial_set', '=',  $levelPlanningUnit->serial_set)
            ->where('status_lus', '=', 'ACTIVE')
            ->with('planningUnitSkills')
            ->with(array('subjectUnitSkills'=>function($query) use ($serial_spu){
                $query->where('serial_spu','=',$serial_spu);
            }));
        $levelUnitSkills= $this->doQueryGet($levelUnitSkill);
        if(sizeof($levelUnitSkills)>0){
            foreach ($levelUnitSkills as $key=>$levelUnitSkillObj){
                $result[$key]['serial_lus']=$levelUnitSkillObj->serial_lus;
                $result[$key]['description_pus']=$levelUnitSkillObj->planningUnitSkills->description_pus;
                $result[$key]['is_ministry_pus']=$levelUnitSkillObj->planningUnitSkills->is_ministry_pus;
                $result[$key]['assigned']=$levelUnitSkillObj->subjectUnitSkills!=null?true:false;
            }
        }else{
            $result= false;
        }
        return $result;
    }


    function saveLevelUnitSkill($serial_lvl,$serial_set,$serial_pus,$serial_aca){
        $levelUnitSkill = new LevelUnitSkill();
        $levelUnitSkill->serial_lvl=$serial_lvl;
        $levelUnitSkill->serial_set=$serial_set;
        $levelUnitSkill->serial_pus=$serial_pus;
        $levelUnitSkill->selectable='YES';
        $levelUnitSkill->status_lus='ACTIVE';
        $levelUnitSkill->serial_aca=$serial_aca;
        $levelUnitSkill->save();
        return $levelUnitSkill;
    }


}
