<?php

namespace App\Repositories;

use App\Models\OptSubjectPeriodActivityType;
use App\Repositories\BaseRepository;

class OptSubjectPeriodActivityTypeRepository extends BaseRepository
{

    protected $modelClass = OptSubjectPeriodActivityType::class;
    protected $optSubjectPeriodActivityType;

    //Declaración del constructor
    public function __construct(OptSubjectPeriodActivityType $optSubjectPeriodActivityType)
    {
        $this->optSubjectPeriodActivityType = $optSubjectPeriodActivityType;
    }

    /**
     * Método que retorna materias optativas por seccion, nivel , especialidad, anio lectivo
     * @since   2017-07-16
     * @author  Erick Vaca <epvaca@rutatec.com>
     * @param   integer serial_scy año lectivo
     * @param   integer $serial_sec seccion
     * @param   integer $serial_spt especialidad
     * @param   integer $serial_lvl nivel
     * @return  ListObject OptionalSubject
     *
     */
    public function getActivityTypesBySubjectBySubperiodByStudent($serial_prd, $serial_osb)
    {
        $activityTypes = $this->newQuery();
        $activityTypes->join('activity_type', 'activity_type.serial_att', '=', 'opt_subject_period_activity_type.serial_att');
        $activityTypes->where('serial_prd', '=', $serial_prd);
        $activityTypes->where('serial_osb', '=', $serial_osb);
        $activityTypes->where('status_osa', '=', 'ACTIVE');
        $activityTypes->where('activity_type.serial_att', '<>', 1);
        $activityTypes->select('activity_type.serial_att', 'activity_type.name_att');
        $activityTypes->orderBy('serial_att');
        return $this->doQueryGet($activityTypes);
    }

}
