<?php

namespace App\Repositories;

use App\Models\Profile;
use App\Repositories\BaseRepository;

class ProfileRepository extends BaseRepository {

    protected $modelClass = Profile::class;
    protected $profile;

    //Declaración del constructor
    public function __construct(Profile $profile) {
        $this->profile = $profile;
    }

    public function getProfiles() {
        return $this->lists('name_prf', 'serial_prf');
    }

    public function getProfilesApp($serial_usr) {
        $profiles = $this->newQuery();
        $profiles->join('user_profile','user_profile.serial_prf','=','profile.serial_prf');
        $profiles->where('serial_usr','=',$serial_usr);
        $profiles->where('status_upr','=','ACTIVE');
        $profiles->where('status_prf', '=', 'ACTIVE');
        $profiles->select('profile.serial_prf','name_prf');
        $profiles->orderBy('serial_prf','DESC');
        return $this->doQueryGet($profiles);
    }

}
