<?php
/**
 * Created by PhpStorm.
 * User: gmronquillo
 * Date: 1/8/2019
 * Time: 16:23
 */

namespace App\Repositories;


use App\Models\SessionPlanningWeek;
use App\Models\UnitPlanningWeek;

class SessionPlanningWeekRepository extends BaseRepository
{
    protected $sessionPlanningWeek;

    public function __construct(SessionPlanningWeek $sessionPlanningWeek)
    {
        $this->sessionPlanningWeek = $sessionPlanningWeek;
    }

    public function saveSessionWeek($session,$serial_upw){

        if(isset($session['serial_spw'])){
        $sessionPlanningWeek = SessionPlanningWeek::where('serial_spw','=',$session['serial_spw'])
            ->first();
        }
        $unitPlanningWeek = UnitPlanningWeek::find($serial_upw);
        if(isset($sessionPlanningWeek)){
            $sessionPlanningWeek->name_spw = isset($session['name_spw']) ? $session['name_spw'] : $sessionPlanningWeek->name_spw;
            $sessionPlanningWeek->objective_spw = isset($session['objective_spw']) ? $session['objective_spw'] : $sessionPlanningWeek->objective_spw;
            $sessionPlanningWeek->activities_spw = isset($session['activities_spw']) ? $session['activities_spw'] : $sessionPlanningWeek->activities_spw;
            $sessionPlanningWeek->resource_spw = isset($session['resource_spw']) ? $session['resource_spw'] : $sessionPlanningWeek->resource_spw;
            $sessionPlanningWeek->evaluation_spw = isset($session['evaluation_spw']) ? $session['evaluation_spw'] : $sessionPlanningWeek->evaluation_spw;
            $sessionPlanningWeek->homework_spw = isset($session['homework_spw']) ? $session['homework_spw'] : $sessionPlanningWeek->homework_spw;
            $sessionPlanningWeek->save();
            if (!$unitPlanningWeek->sessionUnitPlanningWeek->contains($sessionPlanningWeek->serial_spw)) {
                $unitPlanningWeek->sessionUnitPlanningWeek()->attach($sessionPlanningWeek->serial_spw, ['status_suw' => 'ACTIVE']);
            } else {
                $unitPlanningWeek->sessionUnitPlanningWeek()->updateExistingPivot($sessionPlanningWeek->serial_spw, array('status_suw' => 'ACTIVE'), false);
            }
        } else {
            $sessionPlanningWeek = new SessionPlanningWeek($session);
            $sessionPlanningWeek->save();
            if (! $unitPlanningWeek->sessionUnitPlanningWeek->contains($sessionPlanningWeek->serial_spw)) {
                $unitPlanningWeek->sessionUnitPlanningWeek()->attach($sessionPlanningWeek->serial_spw, ['status_suw' => 'ACTIVE']);
            } else {
                $unitPlanningWeek->sessionUnitPlanningWeek()->updateExistingPivot($sessionPlanningWeek->serial_spw, array('status_suw' => 'ACTIVE'), false);
            }
        }
        return $sessionPlanningWeek;
    }

    public function deleteSessionWeek($data){
        $sessionPlanningWeek = SessionPlanningWeek::where('serial_spw','=',$data['serial_spw'])
            ->first();
        $unitPlanningWeek = UnitPlanningWeek::find($data['serial_upw']);
        if($sessionPlanningWeek){
            $sessionPlanningWeek->status_spw = 'INACTIVE';
            $sessionPlanningWeek->save();
            $unitPlanningWeek->sessionUnitPlanningWeek()->updateExistingPivot($sessionPlanningWeek->serial_spw, array('status_suw' => 'INACTIVE'), false);
        }
        return $sessionPlanningWeek;
    }


}