<?php

namespace App\Repositories;

use App\Models\StudentYear;
use App\Models\SchoolYear;
use App\Repositories\BaseRepository;

/**
 * Repositorio del usuario
 * @author Fernando Salas <rfsalas@rutatec.com>
 * @since  2017-05-19
 */
class StudentYearRepository extends BaseRepository {

    protected $modelClass = StudentYear::class;
    protected $studentYear;
    protected $schoolYear;

    //Declaración del constructor
    public function __construct(StudentYear $studentYear, SchoolYear $schoolYear) {
        $this->studentYear = $studentYear;
        $this->schoolYear = $schoolYear;
    }

    /**
     * Devuelve el usuario si es que existe
     *
     * @param   void
     * 
     * @return  object user
     * @throws  InvalidArgumentException
     * @since   2017-05-19
     * @author  Fernando Salas <rfsalas@rutatec.com>
     *
     * @edit    2017-05-19<br />
     *          Fernando Salas <rfsalas@rutatec.com><br />
     *          creación del método<br/>
     *          #edit1
     */
    public function getStudentYear($serial_std, $serial_scy) {
        $studentYear = $this->newQuery();
        $studentYear->join('student', 'student.serial_std', '=', 'student_year.serial_std');
        $studentYear->where('status_sty', '<>', 'RETIRED');
        $studentYear->where('status_std', '=', 'ACTIVE');
        $studentYear->where('student.serial_std', '=', $serial_std);
        $studentYear->where('student_year.serial_scy', '=', $serial_scy);
        return $this->doQueryFirst($studentYear);
    }

}
