<?php

namespace App\Repositories;

use App\Models\SubjectGroupPlanning;


class SubjectGroupPlanningRepository extends BaseRepository {

    protected $modelClass = SubjectGroupPlanning::class;

    protected $subjectGroupPlanning;


    public function __construct(SubjectGroupPlanning $subjectGroupPlanning) {
        $this->subjectGroupPlanning = $subjectGroupPlanning;
    }


    public function getSubjectGroupPlanning($serial_sbc=null,$serial_osb=null,$serial_lvl,$serial_set,$serial_scy) {
        $subjectGroupPlanning = $this->newQuery();
        $subjectGroupPlanning->where('serial_scy',$serial_scy);
        if($serial_sbc){
            $subjectGroupPlanning->where('subject_group_planning.serial_sbc', '=', $serial_sbc);
        }
        if($serial_osb){
            $subjectGroupPlanning->where('subject_group_planning.serial_osb', '=', $serial_osb);
        }
        $subjectGroupPlanning=$subjectGroupPlanning->where('serial_set',$serial_set)
            ->where('serial_lvl',$serial_lvl)
            ->with(['subjectYearPlanning' => function ($subQuery){
                $subQuery->where('subject_year_planning.status_syp','ACTIVE');
            }])->get();
        return $this->doQueryFirst($subjectGroupPlanning);
    }

    public function getMaxGroupPlanning() {
        /*$subjectGroupPlanning = $this->newQuery();
        $subjectGroupPlanning->where('number_group_sgp')
        ->;*/
        $subjectGroupPlanning = SubjectGroupPlanning::whereRaw('number_group_sgp = (select max(`number_group_sgp`) from subject_group_planning)')
        ->select('number_group_sgp')->first();
        return $subjectGroupPlanning;
    }

    public function saveSubjectGroupPlanning($saveData) {
        $subjectGroupPlanning = SubjectGroupPlanning::where('serial_sbc','=',$saveData['serial_sbc'])
        ->where('serial_scy','=',$saveData['serial_scy'])
        ->where('serial_set','=',$saveData['serial_set'])
        ->where('serial_lvl','=',$saveData['serial_lvl'])
        ->first();
        if($subjectGroupPlanning) {
            $subjectGroupPlanning->serial_sbc = isset($saveData['serial_sbc']) ? $saveData['serial_sbc'] : $subjectGroupPlanning->serial_sbc;
            $subjectGroupPlanning->serial_osb = isset($saveData['serial_osb']) ? $saveData['serial_osb'] : $subjectGroupPlanning->serial_osb;
            $subjectGroupPlanning->serial_scy = $saveData['serial_scy'];
            $subjectGroupPlanning->serial_set = $saveData['serial_set'];
            $subjectGroupPlanning->serial_lvl = $saveData['serial_lvl'];
            $subjectGroupPlanning->number_group_sgp = $saveData['number_group_sgp'];
        } else {
            $subjectGroupPlanning = new SubjectGroupPlanning($saveData);
            $subjectGroupPlanning->save();
        }
        return $subjectGroupPlanning;
    }

    public function saveSubjectOptionalGroupPlanning($saveOptionalData) {
        $subjectGroupPlanning = SubjectGroupPlanning::where('serial_osb','=',$saveOptionalData['serial_osb'])
            ->where('serial_scy','=',$saveOptionalData['serial_scy'])
            ->where('serial_set','=',$saveOptionalData['serial_set'])
            ->where('serial_lvl','=',$saveOptionalData['serial_lvl'])
            ->first();
        if($subjectGroupPlanning) {
            $subjectGroupPlanning->serial_sbc = isset($saveOptionalData['serial_sbc']) ? $saveOptionalData['serial_sbc'] : $subjectGroupPlanning->serial_sbc;
            $subjectGroupPlanning->serial_osb = isset($saveOptionalData['serial_osb']) ? $saveOptionalData['serial_osb'] : $subjectGroupPlanning->serial_osb;
            $subjectGroupPlanning->serial_scy = $saveOptionalData['serial_scy'];
            $subjectGroupPlanning->serial_set = $saveOptionalData['serial_set'];
            $subjectGroupPlanning->serial_lvl = $saveOptionalData['serial_lvl'];
            $subjectGroupPlanning->number_group_sgp = $saveOptionalData['number_group_sgp'];
        } else {
            $subjectGroupPlanning = new SubjectGroupPlanning($saveOptionalData);
            $subjectGroupPlanning->save();
        }
        return $subjectGroupPlanning;
    }

    public function subjectGroupPlanning($data) {
        if(isset($data['serial_sbc'])){
        $subjectGroupPlanning = SubjectGroupPlanning::where('serial_sbc','=',$data['serial_sbc'])
            ->where('serial_scy','=',$data['serial_scy'])
            ->where('serial_set','=',$data['serial_set'])
            ->where('serial_lvl','=',$data['serial_lvl'])
            ->where('number_group_sgp','=',$data['number_group_sgp'])
            ->first();
        } else {
            $subjectGroupPlanning = SubjectGroupPlanning::where('serial_osb','=',$data['serial_osb'])
                ->where('serial_scy','=',$data['serial_scy'])
                ->where('serial_set','=',$data['serial_set'])
                ->where('serial_lvl','=',$data['serial_lvl'])
                ->where('number_group_sgp','=',$data['number_group_sgp'])
                ->first();
        }
        if($subjectGroupPlanning) {
            $subjectGroupPlanning->serial_sbc = isset($data['serial_sbc']) ? $data['serial_sbc'] : $subjectGroupPlanning->serial_sbc;
            $subjectGroupPlanning->serial_osb = isset($data['serial_osb']) ? $data['serial_osb'] : $subjectGroupPlanning->serial_osb;
            $subjectGroupPlanning->serial_scy = isset($data['serial_scy']) ? $data['serial_scy'] : $subjectGroupPlanning->serial_scy;
            $subjectGroupPlanning->serial_set = isset($data['serial_set']) ? $data['serial_set'] : $subjectGroupPlanning->serial_set;
            $subjectGroupPlanning->serial_lvl = isset($data['serial_lvl']) ? $data['serial_lvl'] : $subjectGroupPlanning->serial_lvl;
            $subjectGroupPlanning->number_group_sgp = isset($data['number_group_sgp']) ? $data['number_group_sgp'] : $subjectGroupPlanning->number_group_sgp;
            $subjectGroupPlanning->status_sgp = isset($data['status_sgp']) ? $data['status_sgp'] : $subjectGroupPlanning->status_sgp;
            $subjectGroupPlanning->save();
        } else {
            $subjectGroupPlanning = new SubjectGroupPlanning($data);
            $subjectGroupPlanning->save();
        }
        return $subjectGroupPlanning;
    }

}
