<?php
/**
 * Created by PhpStorm.
 * User: gmronquillo
 * Date: 1/8/2019
 * Time: 16:23
 */

namespace App\Repositories;


use App\Models\UnitPlanningWeek;

class UnitPlanningWeekRepository extends BaseRepository
{
    protected $unitPlanningWeek;

    public function __construct(UnitPlanningWeek $unitPlanningWeek)
    {
        $this->unitPlanningWeek = $unitPlanningWeek;
    }

    public function getUnitsPlanningWeek($serial_spu,$serial_sbc,$serial_osb){
        $unitPlanningWeek = UnitPlanningWeek::where('serial_spu','=',$serial_spu)
            //->where('serial_sbc','=',$serial_sbc)
            //->where('serial_osb','=',$serial_osb)
            ->where('status_upw','=','ACTIVE')
            ->with(array('sessionUnitPlanningWeek'=>function($query){
                $query->where('status_spw','=','ACTIVE');
            }))
            ->get();
       return $unitPlanningWeek;

    }

    public function getUnitPlanningWeek($serial_upw){

        $unitPlanningWeek = UnitPlanningWeek::where('serial_upw','=',$serial_upw)
            ->where('status_upw','=','ACTIVE')
            ->with(array('sessionUnitPlanningWeek'=>function($query){
                $query->where('status_spw','=','ACTIVE');
            }))
            ->first();
        return $unitPlanningWeek;

    }

    public function saveUnitPlanningWeek($data){

        $unitPlanningWeek = UnitPlanningWeek::where('serial_upw','=',$data['serial_upw'])
            ->first();

        if($unitPlanningWeek){
            $unitPlanningWeek->serial_spu = isset($data['serial_spu']) ? $data['serial_spu'] : $unitPlanningWeek->serial_spu;
            $unitPlanningWeek->serial_sbc = isset($data['serial_sbc']) ? $data['serial_sbc'] : $unitPlanningWeek->serial_sbc;
            $unitPlanningWeek->serial_osb = isset($data['serial_osb']) ? $data['serial_osb'] : $unitPlanningWeek->serial_osb;
            $unitPlanningWeek->period_upw = isset($data['period_upw']) ? $data['period_upw'] : $unitPlanningWeek->period_upw;
            $unitPlanningWeek->area_upw = isset($data['area_upw']) ? $data['area_upw'] : $unitPlanningWeek->area_upw;
            $unitPlanningWeek->level_upw = isset($data['level_upw']) ? $data['level_upw'] : $unitPlanningWeek->level_upw;
            $unitPlanningWeek->grade_upw = isset($data['grade_upw']) ? $data['grade_upw'] : $unitPlanningWeek->grade_upw;
            $unitPlanningWeek->subject_upw = isset($data['subject_upw']) ? $data['subject_upw'] : $unitPlanningWeek->subject_upw;
            $unitPlanningWeek->teacher_upw = isset($data['teacher_upw']) ? $data['teacher_upw'] : $unitPlanningWeek->teacher_upw;
            $unitPlanningWeek->partial_upw = isset($data['partial_upw']) ? $data['partial_upw'] : $unitPlanningWeek->partial_upw;
            $unitPlanningWeek->number_week_upw = isset($data['number_week_upw']) ? $data['number_week_upw'] : $unitPlanningWeek->number_week_upw;
            $unitPlanningWeek->start_date_upw = isset($data['start_date_upw']) ? $data['start_date_upw'] : $unitPlanningWeek->start_date_upw;
            $unitPlanningWeek->end_date_upw = isset($data['end_date_upw']) ? $data['end_date_upw'] : $unitPlanningWeek->end_date_upw;
            $unitPlanningWeek->observation_upw = isset($data['observation_upw']) ? $data['observation_upw'] : $unitPlanningWeek->observation_upw;
            $unitPlanningWeek->save();
        } else {
            $unitPlanningWeek = new UnitPlanningWeek();
            $unitPlanningWeek->save($data);
        }
        return $unitPlanningWeek;

    }

    public function saveNewPlanningWeek($data) {

        $unitPlanningWeek = new UnitPlanningWeek();
        $unitPlanningWeek->serial_spu = $data['serial_spu'];
        $unitPlanningWeek->name_upw = $data['name_upw'];
        $unitPlanningWeek->save($data);
        return $unitPlanningWeek;

    }

}