<?php

namespace App\Repositories;

use App\Models\UserProfile;
use App\Repositories\BaseRepository;

/**
 * Repositorio del usuario
 * @author Fernando Salas <rfsalas@rutatec.com>
 * @since  2017-05-19
 */
class UserProfileRepository extends BaseRepository {

    protected $modelClass = UserProfile::class;
    //Declaración del constructor
    public function __construct(UserProfile $userProfile) {
        $this->userProfile = $userProfile;
    }

    public function getUserProfiles($serial_usr) {

        $query = $this->newQuery();
        $query->join('profile','profile.serial_prf','=','user_profile.serial_prf');
        $query->where('user_profile.status_upr','ACTIVE');
        $query->where('serial_usr',$serial_usr);
        $query->where('profile.status_prf','ACTIVE');
        $query->select('user_profile.serial_prf', 'profile.name_prf');
        
        return $this->doQueryGet($query);
    }

    public function getUserProfilesMessages($serial_usr_receive,$serial_prf) {

        $query = $this->newQuery();
        $query->join('message_between_profiles','message_between_profiles.pro_serial_prf','=','user_profile.serial_prf');
        $query->where('user_profile.status_upr','ACTIVE');
        $query->where('user_profile.serial_usr',$serial_usr_receive);
        $query->where('message_between_profiles.serial_prf',$serial_prf);
        $query->where('message_between_profiles.status_mbp','ACTIVE');

        return $this->doQueryFirst($query);
    }
    

}
