<?php

/*
  |--------------------------------------------------------------------------
  | Application Routes
  |--------------------------------------------------------------------------
  |
  | Here is where you can register all of the routes for an application.
  | It is a breeze. Simply tell Lumen the URIs it should respond to
  | and give it the Closure to call when that URI is requested.
  |
 */

$app->get('/', function () use ($app) {
    return str_random(32);
});
$app->post('isUser', 'UserController@postIsUser');
$app->post('subjectsEmployee', 'EmployeeController@postSubjectsSchedulesEmployee');
$app->post('studentsByCourse', 'CourseController@postStudentsByCourse');
$app->post('studentsByOptativeSubject', 'OptionalSubjectController@postStudents');
$app->post('attendanceStudents', 'AttendanceController@postListAttendanceStudents');
$app->post('attendanceoptions', 'AttendanceController@postAttendanceOptions');
$app->post('attendanceTypes','AttendanceController@postListAttendanceTypes');
$app->post('saveStudentAttendance','AttendanceController@postSaveStudentAttendance');
$app->post('temporalToken','DeviceController@getTemporalToken');


//Generales
 $app->post('schoolYears','SchoolYearController@getAllSchoolYears');
 $app->post('currentSchoolYear','SchoolYearController@getCurrentSchoolYear');
 $app->get('schoolYear/{serial_scy}','SchoolYearController@getSchoolYearBySerialScy');
 $app->get('sectionsBySchoolYear/{serial_scy}', 'SectionController@getSectionsBySerialScy');
 $app->get('levelsBySchoolYearSection/{serial_scy}/{serial_set}', 'LevelController@getLevelsBySchoolYearSection');
 $app->get('subjectDataBySerialSubjectType/{serial_scy}/{serial_subject}/{type_subject}', 'SubjectController@getSubjectDataBySerialSubjectType');
 $app->get('employeeBySerialUsr/{serial_usr}','EmployeeController@getEmployeeBySerialUsr');
 $app->post('subperiodByDateSerialScySecLvl','SubperiodController@postSubperiodByDateSchoolYearSectionLevel');
 $app->get('subperiodDataBySerialSbp/{serial_sbp}', 'SubperiodController@getSubperiodDataBySerialSbp');
 $app->post('levelSectionYearBySchoolYearSectionLevel','LevelSectionYearController@postLevelSectionYearBySchoolYearSectionLevel');
 $app->get('courseByStudentYear/{serial_std}/{serial_scy}', 'CourseController@getCourseByStudentYear');
 $app->post('schoolYearsActiveCurrent','SchoolYearController@getSchoolYearsActiveCurrent');
 $app->get('studentsByGuardianYear/{serial_grd}/{serial_scy}','StudentGuardianController@getStudentsByGuardianInSchoolYear');
 $app->get('userBySerialUsr/{serial_usr}', 'UserController@getUserBySerialusr');
 $app->get('periodsByStudentYear/{serial_std}/{serial_scy}', 'PeriodController@getPeriodsByYearByStudent');
 $app->get('studentBySerialStd/{serial_std}', 'StudentController@getStudentDataBySerialStd');
 $app->post('teachersBySchoolYearSectionLevelSpecialty', 'EmployeeController@getTeachersBySchoolYearSectionLevelSpecialty');
 $app->post('scheduleByCourseDateDay','ScheduleController@postScheduleByCourseDateDay');
 $app->get('dateDayConfiguration/{date}', 'DateDayConfigurationController@getDateDayConfiguration');
 $app->get('scheduleBySerialScd/{serial_scd}','ScheduleController@getScheduleBySerialScd');
 $app->post('schoolYearsDataActiveCurrent','SchoolYearController@getSchoolYearsDataActiveCurrent');
 $app->post('subjectYearPlanning','PlanningController@postSubjectYearPlanning');
 $app->post('saveSubjectYearPlanning','PlanningController@postSaveSubjectYearPlanning');
 $app->post('checkSubjectToPlanning','PlanningController@postSubjectGroupConfiguration');
 $app->get('selectableGeneralObjectives/{serial_sbc}/{serial_osb}/{serial_lvl}/{serial_set}','PlanningController@getSelectableGeneralObjectivesBySubject');
 $app->post('setGeneralObjectivesToSubjectYearPlanning','PlanningController@postSetGeneralObjectiveToSubject');
 $app->post('createGeneralAreaObjective','PlanningController@postCreateGeneralObjective');
 $app->get('generalObjectivesBySubject/{serial_syp}','PlanningController@getGeneralObjectivesBySubject');


//Calendario de Eventos
$app->group(array('prefix' => 'event'/*,'middleware' =>['before'=>'jwt-auth']*/),function($app) {
    $app->get('profiles', 'ProfileController@getProfiles');
    $app->post('eventProfile', 'EventProfileController@postEventProfile');
    $app->post('createEvent', 'EventController@postCreateEvent');
    $app->post('status', 'EventProfileController@postStatusEvent');
    $app->get('event/{serial_event}', 'EventController@getEvent');
    $app->post('userEvents', 'EventProfileController@postUserEvents');
    $app->post('editEvent', 'EventController@postEditEvent');
    $app->get('eventProfiles/{serial_event}', 'EventController@getEventProfiles');
    $app->get('eventSections/{serial_event}', 'EventController@getEventSections');
    $app->get('holidays', 'EventProfileController@getHolidays');
    $app->get('sections/{startDate}/{endDate}', 'EventController@getListsSectionsByDate');
    $app->get('sectionsByDate/{date}', 'EventController@getSectionsByDate');
});

$app->group(['prefix' => 'skills'], function($app){
    $app->get('skillsAvailableBySubject/{serial_subject}/{subject_type}','SkillsController@getSkillsAvailableBySubjectType');
    $app->get('skillsAssignedBySubject/{serial_subject}/{subject_type}','SkillsController@getSkillsAssignedBySubjectType');
    $app->post('subjectTypes','EnumController@getSubjectTypes');
    $app->post('schoolYears','SchoolYearController@getAllSchoolYears');
    $app->post('currentSchoolYear','SchoolYearController@getCurrentSchoolYear');
    $app->get('sectionLevels/{serial_scy}','SectionController@getSectionSpecialtyLevelBySchoolYear');
    $app->get('mandatorySubjects/{serial_scy}/{serial_set}/{serial_lvl}/{serial_spt}','SubjectCourseController@getSubjectsBySchoolYearSectionLevel');
    $app->get('optionalSubjects/{serial_scy}/{serial_set}/{serial_lvl}/{serial_spt}','OptionalSubjectController@getSubjectsBySchoolYearSectionLevel');
    $app->get('removeSkillSubject/{subject_type}/{serial_skl}/{serial_subjects}','YearSubjectSkillsController@inactivateYearSubjectSkillsBySubjectTypeSkill');
    $app->get('insertSkillSubject/{subject_type}/{serial_skl}/{serial_subject}[/{order}]','YearSubjectSkillsController@insertYearSubjectSkillsBySubjectTypeSkill');
    $app->get('reactivateSkillSubject/{subject_type}/{serial_skl}/{serial_subject}','YearSubjectSkillsController@activateYearSubjectSkillsBySubjectTypeSkill');
    $app->get('getSkillSubject/{subject_type}/{serial_skl}/{serial_subject}','YearSubjectSkillsController@getYearSubjectSkillBySubjectTypeSkill');
    $app->get('reorderSkillSubject/{subject_type}/{serial_skl}/{serial_subject}/{position}','YearSubjectSkillsController@reorderYearSubjectSkillsBySubjectTypeSkill');
});

$app->group(['prefix' => 'incidence'], function($app){
    $app->post('attendanceRelations','IncidenceCategoryController@postIncidenceAttendanceRelations');
    $app->post('saveCategory','IncidenceCategoryController@postSaveIncidenceCategory');
    $app->get('incidenceCategories/{serial_scy}','IncidenceCategoryController@getIncidenceCategoriesByYear');
    $app->post('saveIncidenceYearSectionLevel','IncidenceYearSectionLevelController@postSaveIncidenceYearSectionLevel');
    $app->get('incidenceLevelsBySchoolYearSection/{serial_scy}/{serial_set}','IncidenceYearSectionLevelController@getIncidenceLevelsBySchoolYearSection');
    $app->post('saveIncidenceSetup','IncidenceSetupController@postSaveIncidenceSetup');
    $app->get('incidenceSetupBySchoolYear/{serial_scy}','IncidenceSetupController@getIncidenceSetupByYear');
    $app->get('incidenceSubcategories/{serial_scy}','IncidenceCategoryController@getIncidenceSubcategoriesByYear');
    $app->get('checkIncidenceSubjectLevel/{serial_subject}/{type_subject}','IncidenceYearSectionLevelController@getIncidenceSetupBySubjectType');
    $app->post('incidenceSubjectsEmployee', 'EmployeeController@postIncidenceSubjectsSchedulesEmployee');
    $app->post('saveIncidenceStudent', 'IncidenceStudentController@postSaveIncidenceStudent');
    $app->post('saveStudentIncidences', 'IncidenceStudentController@postSaveStudentIncidences');
    $app->get('studentIncidenceBySerialIst/{serial_ist}', 'IncidenceStudentController@getIncidencesByIncidenceStudent');
    $app->post('listStudents', 'IncidenceStudentController@postListStudents');
    $app->post('listStudentIncidences', 'IncidenceStudentController@postListStudentIncidences');  
    $app->get('incidenceSubcategoriesWithSetup/{serial_scy}','IncidenceCategoryController@getIncidenceSubcategoriesByYearWithSetup');
    $app->get('incidenceCategoryBySerialIca/{serial_ica}','IncidenceCategoryController@getIncidenceCategoryBySerialIca');
    $app->get('incidencesByStudentYearPeriod/{serial_std}/{serial_scy}/{serial_prd}','IncidenceStudentController@getIncidencesByStudentYearPeriod');
    $app->get('incidencePermissionByEmployeeSchoolYear/{serial_emp}/{serial_scy}','EmployeeController@getIncidencePermissionByEmployeeSchoolYear');
    $app->get('incidenceStudentTotalsBySerialIca/{serial_ica}','IncidenceCategoryController@getIncidenceStudentTotalsBySerialIca');
    $app->get('incidenceStudentTotalsBySerialIca/{serial_ica}/{serial_std}/{serial_sbp}','IncidenceCategoryController@getIncidenceStudentTotalsBySerialIcaAndStudent');
    $app->get('incidenceStudentTotalsBySerialIcaParent/{serial_ica}','IncidenceCategoryController@getIncidenceStudentTotalsBySerialIcaParent');
    $app->get('studentRealOptativeSerialScd/{serial_std}/{serial_scy}/{serial_cdt}/{date}/{serial_lop}','IncidenceStudentController@getStudentRealOptativeSerialScd');
    $app->get('checkIncidenceCourse/{serial_crs}','IncidenceYearSectionLevelController@getIncidenceSetupByCourse');
    $app->get('incidencesByStudentYearPeriodSubperiod/{serial_std}/{serial_scy}/{serial_prd}/{serial_sbp}','IncidenceStudentController@getIncidencesByStudentYearPeriodSubperiod');
     $app->post('deleteIncidenceRelatedRecords','IncidenceStudentController@deleteIncidenceRelatedRecordsBySerialStdSubperiod');
});


//autenticaci? de usuarios
$app->group(['prefix' => 'auth'], function($app) {
    $app->post('login', 'AuthController@postLogin');
});
// logout
$app->group(['prefix' => 'auth','middleware' =>['before'=>'jwt-auth']], function($app) {
    $app->post('logout', 'AuthController@postLogout');
});

$app->group(array('prefix' => 'user','middleware' =>['before'=>'jwt-auth']),function($app) {
    $app->post('profilesApp', 'ProfileController@postProfilesApp');
    $app->post('userInfo','UserController@postUserInfo');
});

$app->group(array('prefix' => 'news', 'middleware' => ['before' => 'jwt-auth']), function($app) {
    $app->get('news', 'NewController@getAllNews');
    $app->get('new/{serial_new}', 'NewController@getNew');
    $app->get('webview','NewController@getWebView');
});

$app->group(array('prefix' => 'employee', 'middleware' => ['before' => 'jwt-auth']), function($app) {
    $app->post('icons', 'IconCatalogueController@postIconsEmployee');
    $app->get('employeeBySerialEmp/{serial_emp}','EmployeeController@getEmployeeBySerialEmp');
});

//periodos
$app->group(array('prefix' => 'period', 'middleware' => ['before' => 'jwt-auth']), function($app) {
    $app->get('periods/{serial_std}', 'PeriodController@getPeriods');
    $app->get('subperiods/{serial_prd}', 'SubperiodController@getSubperiods');
});

//actividad
$app->group(array('prefix' => 'activity', 'middleware' => ['before' => 'jwt-auth']), function($app) {
    $app->post('activitydetails','ActivityController@getActivityDetails');    
});


//estudiante
$app->group(array('prefix' => 'student', 'middleware' => ['before' => 'jwt-auth']), function($app) {
    $app->get('subjects/{serial_prd}/{serial_std}', 'StudentController@getSubjectsByStudent');
    $app->get('subjectsyear/{serial_std}', 'StudentController@getSubjectsYearByStudent');
    $app->get('activityTypes/{serial_prd}/{serial}/{serial_std}/{type}/{grade_type}','SubjectPeriodActivityTypeController@getGradesBySubjectBySubperiodByStudent');
    $app->get('activities/{serial}/{serial_sbp}/{serial_std}/{serial_att}/{type}','ActivityController@getActivitiesBySubperiodByStudent');
    $app->get('activitiesPeriod/{serial_std}[/{serial_act}]','ActivityController@getActivitiesByPeriodByStudent');
    $app->get('companionBySerialStd/{serial_std}','CourseController@getStudentCompanionBySerialStd');
    $app->get('studentCard/{serial_std}','StudentController@getStudentCard');
    $app->get('guardiansStudent/{serial_std}','StudentController@getGuardiansStudent');       
    $app->get('scheduleBySerialStd/{serial_std}','ScheduleController@getScheduleBySerialStd');
    $app->get('guardiansByStudent/{serial_std}','StudentController@getGuardiansBySerialStd');
});

//mensajes
$app->group(array('prefix' => 'messages', 'middleware' => ['before' => 'jwt-auth']), function ($app) {
    $app->get('messages/{serial_usr}', 'MessageController@getMessagesByUser');
    $app->get('message/{serial_msg}', 'MessageController@getDetailMessage');
    $app->post('deleteMessage', 'MessageController@postDeleteMessage');
    $app->post('readMessage', 'MessageController@postReadMessage');
    $app->get('deleteMessages/{serial_usr}', 'MessageController@getDeletedMessages');
    $app->get('unreadMessages/{serial_usr}', 'MessageController@getUnreadMessagesByUser');
    $app->post('deleteMessageList', 'MessageController@postDeleteMessageList');
    $app->post('suggestion','MailSuggestionController@getSuggestion');
    $app->get('suggestions','MailSuggestionController@getSuggestions');
    $app->post('replyMessage','MessageController@postResponseMessage');
});


$app->group(array('prefix'=>'planning'),function ($app){
    //objetivos especificos
    $app->get('selectableSpecificObjectives/{serial_sbc}/{serial_osb}/{serial_lvl}/{serial_set}','PlanningController@getSelectableSpecificObjectivesBySubject');
    $app->post('setSpecificObjectivesToSubjectYearPlanning','PlanningController@postSetSpecificObjectiveToSubject');
    $app->post('createSpecificObjective','PlanningController@postCreateSpecificObjective');
    $app->get('specificObjectivesBySubject/{serial_syp}','PlanningController@getSpecificObjectivesBySubject');
    //ejes transversales
    $app->get('selectableTransverseAxis/{serial_sbc}/{serial_osb}/{serial_lvl}/{serial_set}','PlanningController@getSelectableTransverseAxesBySubject');
    $app->post('setTransverseAxisToSubjectYearPlanning','PlanningController@postSetTransverseAxesToSubject');
    $app->post('createTransverseAxis','PlanningController@postCreateTransverseAxis');
    $app->get('transverseAxesBySubject/{serial_syp}','PlanningController@getTransverseAxesBySubject');
    //unidades de planificacion
    $app->get('selectablePlanningUnits/{serial_sbc}/{serial_osb}/{serial_lvl}/{serial_set}','PlanningController@getSelectablePlanningUnitsBySubject');
    $app->post('setPlanningUnitToSubjectYearPlanning','PlanningController@postSetPlanningUnitToSubject');
    $app->post('createPlanningUnit','PlanningController@postCreatePlanningUnit');
    $app->get('planningUnitBySubject/{serial_syp}','PlanningController@getPlanningUnitsBySubject');
    $app->get('levelForm/{serial_syp}','PlanningController@getLevelForm');
});

$app->group(array('prefix'=>'unit_planning'),function ($app){
    //Fechas unidades de planificacion
    $app->get('planningUnitDetail/{serial_spu}','PlanningController@getPlanningUnitDetail');
    $app->post('datesUnitPlanning','PlanningController@postSetDatesSubjectUnit');

    //objetivos especificos unidades de planificacion
    $app->get('selectableUnitSpecificObjectives/{serial_spu}','PlanningController@getSelectableSpecificObjectivesBySubjectUnit');
    $app->post('setSpecificObjectivesToSubjectUnit','PlanningController@postSetSpecificObjectiveToSubjectUnit');
    $app->post('createSpecificObjectiveUnit','PlanningController@postCreateSpecificObjectiveUnit');
    $app->get('specificObjectivesBySubjectUnit/{serial_spu}','PlanningController@getSpecificObjectivesBySubjectUnit');

    //destrezas de unidades de planificacion
    $app->get('selectableUnitSkills/{serial_spu}','PlanningController@getSelectableSkillsBySubjectUnit');
    $app->post('setSkillsToSubjectUnit','PlanningController@postSetSkillToSubjectUnit');
    $app->post('createSkillUnit','PlanningController@postCreateSkillUnit');
    $app->get('skillsBySubjectUnit/{serial_spu}','PlanningController@getSkillsBySubjectUnit');

    //Orientaciones Metodologicas
    $app->get('selectableUnitMethodologicalOrientation/{serial_spu}','PlanningController@getSelectableMethodologicalOrientationBySubjectUnit');
    $app->post('setMethodologicalOrientationToSubjectUnit','PlanningController@postSetMethodologicalOrientationToSubjectUnit');
    $app->post('createMethodologicalOrientationUnit','PlanningController@postCreateMethodologicalOrientationUnit');
    $app->get('methodologicalOrientationBySubjectUnit/{serial_spu}','PlanningController@getMethodologicalOrientationBySubjectUnit');

    //indicadores de evaluacion
    $app->get('selectableUnitEvaluationIndicator/{serial_spu}','PlanningController@getSelectableEvaluationIndicatorBySubjectUnit');
    $app->post('setEvaluationIndicatorToSubjectUnit','PlanningController@postSetEvaluationIndicatorToSubjectUnit');
    $app->post('createEvaluationIndicatorUnit','PlanningController@postCreateEvaluationIndicatorUnit');
    $app->get('evaluationIndicatorBySubjectUnit/{serial_spu}','PlanningController@getEvaluationIndicatorBySubjectUnit');

    //ejes transversales
    $app->get('selectableUnitTransverse/{serial_spu}','PlanningController@getSelectableTransverseBySubjectUnit');
    $app->post('setTransverseToSubjectUnit','PlanningController@postSetTransverseToSubjectUnit');
    $app->post('createTransverseUnit','PlanningController@postCreateTransverseUnit');
    $app->get('transverseBySubjectUnit/{serial_spu}','PlanningController@getTransverseBySubjectUnit');

    //estrategias metodologicas
    $app->get('selectableUnitMethodologicalStrategies/{serial_spu}','PlanningController@getSelectableMethodologicalStrategiesBySubjectUnit');
    $app->post('setMethodologicalStrategiesToSubjectUnit','PlanningController@postSetMethodologicalStrategiesToSubjectUnit');
    $app->post('createMethodologicalStrategiesUnit','PlanningController@postCreateMethodologicalStrategiesUnit');
    $app->get('methodologicalStrategiesBySubjectUnit/{serial_spu}','PlanningController@getMethodologicalStrategiesBySubjectUnit');

    //Recursos
    $app->get('selectableUnitResource/{serial_spu}','PlanningController@getSelectableResourceBySubjectUnit');
    $app->post('setResourceToSubjectUnit','PlanningController@postSetResourceToSubjectUnit');
    $app->post('createResourceUnit','PlanningController@postCreateResourceUnit');
    $app->get('resourceBySubjectUnit/{serial_spu}','PlanningController@getResourceBySubjectUnit');

    //Indicadores de logro
    $app->get('selectableUnitAchievementIndicators/{serial_spu}','PlanningController@getSelectableAchievementIndicatorsBySubjectUnit');
    $app->post('setAchievementIndicatorsToSubjectUnit','PlanningController@postSetAchievementIndicatorsToSubjectUnit');
    $app->post('createAchievementIndicatorsUnit','PlanningController@postCreateAchievementIndicatorsUnit');
    $app->get('achievementIndicatorsBySubjectUnit/{serial_spu}','PlanningController@getAchievementIndicatorsBySubjectUnit');

    //formularios
    $app->get('unitPlanningFormData/{serial_put}/{serial_spu}/{serial_sbc}/{serial_osb}','PlanningController@getUnitPlanningFormDataBySubject');
    $app->post('saveUnitDataForm','PlanningController@postSaveUnitForm');
});

$app->get('academicArea/{serial_scy}/{serial_set}/{serial_lvl}','CourseController@getAcademicArea');
$app->get('levelsAcademicArea/{serial_scy}/{serial_aca}','CourseController@getLevelsAcademicArea');
$app->get('subjectUnitPlanner/{serial_scy}/{serial_set}/{serial_lvl}/{serial_aca}','CourseController@getSubject');
$app->get('subjectConfigUnitPlanner/{serial_scy}/{serial_set}/{serial_lvl}/{serial_aca}','CourseController@getSubjectConfig');
$app->get('subjectConfigInfo/{serial_scy}/{serial_set}/{serial_lvl}/{serial_aca}','CourseController@getSubjectConfigInfo');
$app->post('saveConfigUnitPlanner','PlanningController@saveConfigUnitPlanner');
$app->post('saveSubjectConfig','PlanningController@saveSubjectConfig');
$app->get('getUnitPlannerWeek/{serial_upw}','PlanningController@getUnitPlannerWeek');
$app->post('saveUnitPlannerWeek','PlanningController@postSaveUnitPlannerWeek');
$app->post('newUnitPlanningWeek','PlanningController@postNewPlanningWeek');
$app->post('deleteSessionWeek','PlanningController@postDeleteSessionWeek');
$app->post('unitsPlanning','CourseController@postUnitsPlanning');
$app->get('unitsPlanningWeek/{serial_spu}/{serial_sbc}/{serial_osb}','PlanningController@getUnitsPlanningWeek');
$app->post('yearPlanningReport','PlanningController@postYearPlanningReport');
$app->post('blockPlanningReport','PlanningController@postBlockPlanningReport');

//nuevo proceso de admissiones
$app->group(['prefix' => 'admissions'], function($app) {
    $app->get('allCountries', 'CountryController@getCountries');
    $app->post('stateBySerialCountry', 'StateController@getStates');
    $app->post('countiesBySerialState', 'CountyController@getCounties');
    $app->post('parishBySerialCounty', 'ParishController@getParish');
    $app->post('zoneAddressBySerialParish', 'ZoneAddressController@getZoneAddress');
    $app->get('schoolYearAdmission', 'SchoolYearController@getSchoolYearForAdmissions');
    $app->post('sectionApplicantStudent', 'SectionController@getSectionBySchoolYear');
    $app->post('levelApplicantStudent', 'LevelSectionYearController@getLevelByYearAndSection');
    $app->post('applicantGuardian', 'ApplicantGuardianController@postSaveApplicantGuardian');
    $app->post('getApplicantsStudents', 'ApplicantStudentController@getApplicantsStudents');
    $app->post('visitedSchoolStd', 'ApplicantStudentController@saveVisitedSchoolStd');
    $app->post('proceedStudent', 'ApplicantStudentController@saveProceedStudent');
    $app->post('flagOne', 'ApplicantStudentController@saveFlagOne');
    $app->post('flagTwo', 'ApplicantStudentController@saveFlagTwo');
    $app->post('flagThree', 'ApplicantStudentController@saveFlagThree');
    $app->post('employeeSection', 'ApplicantStudentController@getEmployeeSection');
    $app->post('employeeLevel', 'EmployeeController@getEmployeeLevel');
    $app->post('applicant', 'ApplicantStudentController@getApplicant');
    $app->post('applicantObservation', 'ApplicantStudentController@saveObservation');
    $app->post('allSections', 'ApplicantStudentController@getAllSections');
    $app->post('allLevels', 'ApplicantStudentController@getAllLevels');
    $app->get('nameSchool', 'SchoolSetupController@getNameSchool');
});

//test mail;
$app->get('mailTest/{mailFrom}/{mailTo}','MailSuggestionController@getSuggestions');
